program prprdklf;

Uses
 dos,crt,js_sub,js_stm;

Var
  StMod:    StMod_T;
  f:        Text;
  i,j,k:    Word;
  anz:      Word;
  clslst:   ClsLst_T;
  koeff:    array[1..AnzElemMod,1..AnzElemMod] of Real;
  aprio:    array[1..AnzElemMod] of Real;
  found:    Boolean;


begin
if      ParamCount=0 then
  begin
  writeln('usage:  StatMod-Dateiname  RBas-Dateiname');
  writeln;
  writeln('        Wandelt Statistisches Modell in Klassifikator');
  writeln('        fr die Schtzung der klassenspezif. Wahrsch. um');
  writeln;
  end
else if Paramcount=2 then
  begin
  LoadStMod(ParamStr(1),StMod,OK);
  StModInit(StMod);
  Assign(f,ParamStr(2)); Rewrite(f);
  anz:=ModPar.anz;
  i:=0;

  for k:=1 to anz do
   begin
   found:=False; j:=0;
   while (not found) and (j<anz) do
    begin
    Inc(j); if clslst[j]=ModPar.par[k].class then found:=True;
    end;
   if not found then begin
                     Inc(i);
                     clslst[i]:=ModPar.par[k].class;
                     j:=i;
                     end;
   koeff[k,j]:=ModPar.par[k].apr;
   end;

  for j:=1 to i do
   begin
   aprio[j]:=0;
   for k:=1 to anz do
    begin
    aprio[j]:=aprio[j]+koeff[k,j];
    end;
   for k:=1 to anz do koeff[k,j]:=koeff[k,j]/aprio[j];
   end;

  writeln(f,'NumbOfClasses: ',i:3);
  writeln(f,'NumbOfRdb:     ',anz:3);
  writeln(f);

  write(f,'Classes:');
  for j:=1 to i do write(f,'    ',clslst[j],'       ');
  writeln(f);
  writeln(f);

  write(f,'APrio:  ');
  for j:=1 to i do write(f,aprio[j]:12:6);
  writeln(f);
  writeln(f);

  for k:=1 to anz do
   begin
   if k=1 then write(f,'Koeff:  ') else write(f,'        ');
   for j:=1 to i do write(f,koeff[k,j]:12:6);
   writeln(f);
   end;

  Close(f);
  end
else writeln('Fehlerhafte Parameterversorgung');
end.

end.