program MDLHSTe;

{$M 16000,0,40000}


Uses
 graph,dos,crt,
 js_sub,js_acc,js_key,js_tio,js_fio,js_koor,
 js_stm,js_mtr,js_gra,pc_mouse,js_qmx,js_mdlh,js_glbw;

Var
 ch:         Char;
 k:          Word;
 w:          Word;
 i,j:        Integer;
 wert:       Real;
 s:          String;

 PfadeMaske:  MskPar_T;
 KoorMaske:   MskPar_T;
 FarbeMaske:  MskPar_T;

 Histogr:     Hist_T;
 ClustTab:    ClustTab_T;
 ClustTabEig: ClustTab_T;
 ClustTabFrm: ClustTab_T;
 GrenzTab:    GrenzTab_T;
 NewGrenz:    GrenzTab_T;

 TasteMain      : FktTst;
   TastePlot    : FktTst;
   TasteKoor    : FktTst;
   TasteHist    : FktTst;
   TasteModell  : FktTst;
   TasteDirekt  : FktTst;
    TasteTools  : FktTst;
     TasteGradOp: FktTst;
     TasteRandOp: FktTst;
     TasteFilt_G: FktTst;
     TasteFilt_H: FktTst;
   TasteParam   : FktTst;
     TastePfade : FktTst;
     TasteFarbe : FktTst;


Const
 KeysMain:   KeyTxt =('Main',
                      '->PLOT','->COOR','->DRCT','->HIST','-> MDL',
                      'SV_CLS','->PARA','-> EDI','-> DOS','IMGEXT');

 KeysPlot:   KeyTxt =('Plot',
                      '  COOR','  HIST',' CLUST','   NVT','APPROX',
                      'WIDFCT','MOVETH','CLSTTH',' CLEAR','MAIN<-');

 KeysKoor:   KeyTxt =('Coor',
                      '  PLOT','  EDIT','LD_COO','SV_COO','      ',
                      '      ','      ',' IMAGE',' CLEAR','MAIN<-');

 KeysHist:   KeyTxt =('Hist',
                      '  COOR','  PLOT','RDHIST','GETPLT','......',
                      'SELECT','MK_MOD',' IMAGE',' CLEAR','MAIN<-');

 KeysModell: KeyTxt =('Model',
                      '  COOR','  HIST',' MODEL','CNFFCT','......',
                      'NVTEIG','NVTFRM',' IMAGE',' CLEAR','MAIN<-');

 KeysParam:  KeyTxt =('Param',
                      '->PATH','->COLS','WCOLOR','WRTIMG','WIDFCT',
                      '......','......','......','......','MAIN<-');

 KeysDirekt: KeyTxt =('Direct',
                      '  COOR','GETHST','PLTEIG','PLTFRM','PLTCNF',
                      '->TOOL','......',' IMAGE',' CLEAR','MAIN<-');

 KeysTools:  KeyTxt =('Tools',
                      '      ','      ','GRADOP','RANDOP','->FLTC',
                      '->FLTH','......','      ','      ','DRCT<-');

 KeysGradOp: KeyTxt =('Gradop',
                      '  COOR','PLTMOD','OPTMOD','OPTSTP',' RESET',
                      'LMTGRD','......',' IMAGE',' CLEAR','TOOL<-');

 KeysRandOp: KeyTxt =('Randop',
                      '  COOR','PLTMOD','OPTMOD','OPTSTP',' RESET',
                      'SIMFAC','......',' IMAGE',' CLEAR','TOOL<-');

 KeysFilt_G: KeyTxt =('Filt_C',
                      '  COOR','PLTCNF',' MKCNF','MEDIAN','  MEAN',
                      ' GAUSS','FLTPAR',' IMAGE',' CLEAR','TOOL<-');

 KeysFilt_H: KeyTxt =('Filt_H',
                      '  COOR','PLTHST',' MKCNF','MEDIAN','  MEAN',
                      ' GAUSS','FLTPAR',' IMAGE',' CLEAR','TOOL<-');

 KeysPfade:  KeyTxt =('Paths',
                      '      ','  EDIT','LD_PFD','SV_PFD','      ',
                      '      ','      ','      ','      ','PARA<-');

 KeysFarbe:  KeyTxt =('Colors',
                      '      ','  EDIT','LD_FRB','SV_FRB','      ',
                      '      ','      ','      ','      ','PARA<-');




procedure PfadeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPfade,TastePfade);
  case TastePfade of
   2: begin
      EditMskG(PfadeMaske,OK,rm);
      PfadeInitMdl(PfadeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Paths and Defaults');
      GtRdFileNameG(100,100,PfadePfad,PfadeRdDatei);
      if not Leer(PfadeRdDatei) then begin
                                     LoadMsk(PfadeRdDatei,PfadeMaske,OK);
                                     PfadeInitMdl(PfadeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Paths and Defaults');
      GtWrFileNameG(100,100,PfadePfad,PfadeSvDatei);
      if not Leer(PfadeSvDatei) then SaveMsk(PfadeSvDatei,PfadeMaske,OK);
      ClrDskTpG(ActPage);
      end;
  end;
 until TastePfade=10;
 end;


procedure FarbeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysFarbe,TasteFarbe);
  case TasteFarbe of
   2: begin
      EditMskG(FarbeMaske,OK,rm);
      ColorInitMdl(FarbeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Presentation Parameters');
      GtRdFileNameG(100,100,FarbePfad,FarbeRdDatei);
      if not Leer(FarbeRdDatei) then begin
                                     LoadMsk(FarbeRdDatei,FarbeMaske,OK);
                                     ColorInitMdl(FarbeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Presentation Parameters');
      GtWrFileNameG(100,100,FarbePfad,FarbeSvDatei);
      if not Leer(FarbeSvDatei) then SaveMsk(FarbeSvDatei,FarbeMaske,OK);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteFarbe=10;
 end;


procedure ParamKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysParam,TasteParam);
  case TasteParam of
   1: PfadeKeys;
   2: FarbeKeys;
   3: begin
      repeat
       s:=ColorToStr(BeschrColor);
       OvWrt:=True;
       GetStr('Color for Writing Text in Image: ',12,s);
       BeschrColor:=ColorFromStr(s);
      until BeschrColor<=15;
      ClrDskTpG(ActPage);
      end;
   4: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  TextColor(BeschrColor);
                  TextBackGround(DsktpColor[ActPage]);
                  Beschrifte;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   5: begin
      Message('Determine Widening Factor for Gaussians');
      GetWertR('Widening Factor = ',GlFaktor);
      ClrDsktpG(ActPage);
      end;
   6: begin
      DsplApp:=not DsplApp;
      if DsplApp   then KeysParam[6]:='   APP'
                   else KeysParam[6]:='NO_APP';
      end;
   7: begin
      DsplErr:=not DsplErr;
      if DsplErr   then KeysParam[7]:='   ERR'
                   else KeysParam[7]:='NO_ERR';
      end;
   8: begin
      DsplNvt:=not DsplNvt;
      if DsplNvt   then KeysParam[8]:='   NVT'
                   else KeysParam[8]:='NO_NVT';
      end;
   9: begin
      SnglStp:=not SnglStp;
      if SnglStp   then KeysParam[9]:='  STEP'
                   else KeysParam[9]:='NOSTEP';
      end;
  end;
 until TasteParam=10;
 end;


procedure HistKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysHist,TasteHist);
  case TasteHist of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  PlotHist(Histogr,HistColor,HistLineStyle);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   3: begin
      Message('Select Inputfile Histogram');
      GtRdFileNameG(100,100,HistPfad,HistRdDatei);
      if not Leer(HistRdDatei) then
       begin
       LoadEigFrmHist(HistRdDatei,OK);
       ClSlctFromClsLst(ClsLst,KlAnz,ClSlct);
       HistFertig:=OK;
       end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      if not HistFertig then begin
                             ErrorMessage('No Histogram available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   PlotGetEigFrmHist(SlctLabel,HistType,Histogr);
                   HistogrFertig:=True;
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   5: begin
      HistType:=(Histtype+1) mod 3;
      case HistType of
       0: begin
          KeysHist[5]:=' EIGEN';
          KeysModell[5]:=' EIGEN';
          end;
       1: begin
          KeysHist[5]:=' FREMD';
          KeysModell[5]:=' FREMD';
          end;
       2: begin
          KeysHist[5]:='  BOTH';
          KeysModell[5]:='  BOTH';
          end;
      end;
      end;
   6: begin
      s:=''; for k:=1 to KlAnz do s:=s+ClsLst[k]+' ';
      Message('Label from '+s+'or SpaceBar');
      s:=SlctLabel;
      repeat
       GetStr('Class Label : ',1,s);
       SlctLabel:=s[1];
      until SlctLabel in (ClSlct+[#32]);
      ClrDskTpG(ActPage);
      end;
   7: begin
      if not HistFertig then begin
                             ErrorMessage('No Histogram available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   PlotGetEigFrmHist(SlctLabel,0,Histogr);
                   GoThru(Histogr,GrenzTab,ClustTab,NewGrenz);
                   ClustTabEig:=ClustTab; ModEigFertig:=True;
                   PlotGetEigFrmHist(SlctLabel,1,Histogr);
                   GoThru(Histogr,GrenzTab,ClustTab,NewGrenz);
                   ClustTabFrm:=ClustTab; ModFrmFertig:=True;
                 {  HistogrFertig:=True;}
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteHist=10;
 end;



procedure ModellKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysModell,TasteModell);
  case TasteModell of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      if not HistFertig then begin
                             ErrorMessage('No Histogram available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   PlotEigFrmHist(SlctLabel,HistType);
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   3: begin
      if (HistType in [0,2]) and not ModEigFertig then
       begin
       ErrorMessage('No Eigen-Model available');
       WaitForReturn;
       ClrDskTpG(ActPage);
       end;
      if (HistType in [1,2]) and not ModFrmFertig then
       begin
       ErrorMessage('No Fremd-Model available');
       WaitForReturn;
       ClrDskTpG(ActPage);
       end;

      if ((HistType in [0,2]) and ModEigFertig) or
         ((HistType in [1,2]) and ModFrmFertig) then
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   SetColor(EigHistColor);
                   L_art:=LMuster[0];
                   if HistType in [0,2] then PlotAppFkt(ClustTabEig);
                   if HistType in [1,2] then PlotAppFkt(ClustTabFrm);
       WaitForReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   4: begin
       if not (ModEigFertig and ModFrmFertig) then
        begin
        ErrorMessage('No Eigen- and Fremd-Model available');
        WaitForReturn;
        ClrDskTpG(ActPage);
        end
       else
        begin
        ActPage:=1; SetActivePage(ActPage);
                    SetVisualPage(ActPage);
                    SetColor(GlbwColor);
                    L_art:=LMuster[GlbwLineStyle];
                    PlotGlbwFkt(ClustTabEig,ClustTabFrm);
       WaitForReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   5: begin
      HistType:=(Histtype+1) mod 3;
      case HistType of
       0: begin
          KeysModell[5]:=' EIGEN';
          KeysHist[5]:=' EIGEN';
          end;
       1: begin
          KeysModell[5]:=' FREMD';
          KeysHist[5]:=' FREMD';
          end;
       2: begin
          KeysModell[5]:='  BOTH';
          KeysHist[5]:='  BOTH';
          end;
      end;
      end;
   6: begin
      if not ModEigFertig then
       begin
       ErrorMessage('No Eigen-Model available');
       WaitForReturn;
       ClrDskTpG(ActPage);
       end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   DsplNvts(ClustTabEig);
       WaitForReturn;
       ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
       end;
      end;
   7: begin
      if not ModFrmFertig then
       begin
       ErrorMessage('No Fremd-Model available');
       WaitForReturn;
       ClrDskTpG(ActPage);
       end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   DsplNvts(ClustTabFrm);
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteModell=10;
 end;



procedure GradOpKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysGradOp,TasteGradOp);
  case TasteGradOp of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      if not HistGlbwFertig then
                            begin
                            ErrorMessage('No Confidence Histogram available');
                            WaitForReturn;
                            ClrDskTpG(ActPage);
                            end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   if not IncGlbwColor then AktGlbwColor:=GlbwColor;
                   PlotGlbwModell;
                   if IncGlbwColor then begin
                                        AktGlbwColor:=(AktGlbwColor+1) Mod 16;
                                        if AktGlbwColor=DsktpColor[1] then Inc(AktGlbwColor);
                                        end;
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   3: begin
      if HistGlbwFertig and HistEigFrmFertig then
       begin
       if DsplOpt then begin
                       ActPage:=1; SetActivePage(ActPage);
                                   SetVisualPage(ActPage);
                                   OptimGlbwModGradAbstieg;
                       WaitforReturn;
                       ActPage:=0; SetActivePage(ActPage);
                                   SetVisualPage(ActPage);
                       end
                  else OptimGlbwModGradAbstieg;
       end;
      end;
   4: begin
      Message('Determine Stepwidth for Gradient Search');
      GetWertR('OptStepGrad = ',OptStepGrad);
      ClrDsktpG(ActPage);
      OptStepGradMax :=64*OptStepGrad;
      end;
   5: begin
      ParGlbwMod:=ParGlbwModInit;
      OptStepGrad:=OptStepGradInit;
      SimFakGrad :=SimFakGradInit;
      end;
   6: begin
      Message('Determine Stopping Criterion LimitGrad');
      GetWertR('LimitGrad = ',LimitGrad);
      ClrDsktpG(ActPage);
      end;
   7: begin
      DsplOpt:=not DsplOpt;
      if DsplOpt   then begin
                        KeysGradOp[7]:='   DSP';
                        KeysRandOp[7]:='   DSP';
                        end
                   else begin
                        KeysGradOp[7]:='NO_DSP';
                        KeysRandOp[7]:='NO_DSP';
                        end;
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteGradOp=10;
 end;


procedure RandOpKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysRandOp,TasteRandOp);
  case TasteRandOp of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      if not HistGlbwFertig then
                            begin
                            ErrorMessage('No Confidence Histogram available');
                            WaitForReturn;
                            ClrDskTpG(ActPage);
                            end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   if not IncGlbwColor then AktGlbwColor:=GlbwColor;
                   PlotGlbwModell;
                   if IncGlbwColor then begin
                                        AktGlbwColor:=(AktGlbwColor+1) Mod 16;
                                        if AktGlbwColor=DsktpColor[1] then Inc(AktGlbwColor);
                                        end;
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   3: begin
      if HistGlbwFertig and HistEigFrmFertig then
       begin
       if DsplOpt then begin
                       ActPage:=1; SetActivePage(ActPage);
                                   SetVisualPage(ActPage);
                                   OptimGlbwMod;
                       WaitforReturn;
                       ActPage:=0; SetActivePage(ActPage);
                                   SetVisualPage(ActPage);
                       end
                  else OptimGlbwMod;
       end;
      end;
   4: begin
      Message('Determine Stepwidth for Random Optimization');
      GetWertR('OptStepRand = ',OptStepRand);
      ClrDsktpG(ActPage);
      end;
   5: begin
      ParGlbwMod:=ParGlbwModInit;
      OptStepRand:=OptStepRandInit;
      SimFakRand :=SimFakRandInit;
      end;
   6: begin
      Message('Determine Annealing Factor');
      GetWertR('SimFakRand = ',SimFakRand);
      ClrDsktpG(ActPage);
      end;
   7: begin
      DsplOpt:=not DsplOpt;
      if DsplOpt   then begin
                        KeysRandOp[7]:='   DSP';
                        KeysGradOp[7]:='   DSP';
                        end
                   else begin
                        KeysRandOp[7]:='NO_DSP';
                        KeysGradOp[7]:='NO_DSP';
                        end;
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteRandOp=10;
 end;


procedure Filt_GKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysFilt_G,TasteFilt_G);
  case TasteFilt_G of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      if not HistGlbwFertig then
                            begin
                            ErrorMessage('No Confidence Histogram available');
                            WaitForReturn;
                            ClrDskTpG(ActPage);
                            end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   if not IncGlbwColor then AktGlbwColor:=GlbwColor;
                   PlotGlbwFromHistGlbw;
                   if IncGlbwColor then begin
                                        AktGlbwColor:=(AktGlbwColor+1) Mod 16;
                                        if AktGlbwColor=DsktpColor[1] then Inc(AktGlbwColor);
                                        end;
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   3: MakeHistGlbw;
   4: FiltHistMedian(FiltPar,HistGlbw,HistGlbw);
   5: FiltHistAver(FiltPar,HistGlbw,HistGlbw);
   6: FiltHistGauss(FiltPar,HistGlbw,HistGlbw);
   7: begin
      Message('Determine Filter Width: FiltPar=[1..9]');
      repeat GetWertI('FiltPar = ',FiltPar) until Filtpar in [1..9];
      ClrDsktpG(ActPage);
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteFilt_G=10;
 end;


procedure Filt_HKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysFilt_H,TasteFilt_H);
  case TasteFilt_H of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      if not HistEigFrmFertig then
                             begin
                             ErrorMessage('No Eigen- and Fremd-Histogram available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   PlotHistFkt(HistEig,EigHistColor,EigHistLineStyle);
                   PlotHistFkt(HistFrm,FrmHistColor,FrmHistLineStyle);
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   3: MakeHistGlbw;
   4: begin
      FiltHistMedian(FiltPar,HistEig,HistEig);
      FiltHistMedian(FiltPar,HistFrm,HistFrm);
      end;
   5: begin
      FiltHistAver(FiltPar,HistEig,Histeig);
      FiltHistAver(FiltPar,HistFrm,HistFrm);
      end;
   6: begin
      FiltHistGauss(FiltPar,HistEig,Histeig);
      FiltHistGauss(FiltPar,HistFrm,HistFrm);
      end;
   7: begin
      Message('Determine Filter Width: FiltPar=[1..9]');
      repeat GetWertI('FiltPar = ',FiltPar) until Filtpar in [1..9];
      ClrDsktpG(ActPage);
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteFilt_H=10;
 end;




procedure ToolsKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysTools,TasteTools);
  case TasteTools of
   3: GradOpKeys;
   4: RandOpKeys;
   5: Filt_GKeys;
   6: Filt_HKeys;
   7: begin
      PrtkOpt:=not PrtkOpt;
      if PrtkOpt   then KeysTools[7]:='  PRTC'
                   else KeysTools[7]:='NOPRTC';
      end;
  end;
 until TasteTools=10;
 end;




procedure DirektKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysDirekt,TasteDirekt);
  case TasteDirekt of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      if not HistFertig then begin
                             ErrorMessage('No Histogram available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
                        else begin
                             GetEigFrmHist(SlctLabel);
                             SumEig:=SumHist(HistEig);
                             SumFrm:=SumHist(HistFrm);
                             HistEigFrmFertig:=True;
                             MakeHistGlbw;
                             HistGlbwFertig:=True;
                             end;
      end;
   3: begin
      if not HistEigFrmFertig then
                             begin
                             ErrorMessage('No Eigen- and Fremd-Histogram available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   PlotHist(HistEig,EigHistColor,EigHistLineStyle);
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   4: begin
      if not HistEigFrmFertig then
                             begin
                             ErrorMessage('No Eigen- and Fremd-Histogram available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   PlotHist(HistFrm,FrmHistColor,FrmHistLineStyle);
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   5: begin
      if not HistGlbwFertig then
                            begin
                            ErrorMessage('No Confidence Histogram available');
                            WaitForReturn;
                            ClrDskTpG(ActPage);
                            end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   if not IncGlbwColor then AktGlbwColor:=GlbwColor;
                   PlotGlbwFromHistGlbw;
                   if IncGlbwColor then begin
                                        AktGlbwColor:=(AktGlbwColor+1) Mod 16;
                                        if AktGlbwColor=DsktpColor[1] then Inc(AktGlbwColor);
                                        end;
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   6: ToolsKeys;
   7: begin
      IncGlbwColor:=not IncGlbwColor;
      if IncGlbwColor then KeysDirekt[7]:='INCCOL'
                      else KeysDirekt[7]:='FIXCOL'
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteDirekt=10;
 end;





procedure KoorKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysKoor,TasteKoor);
  case TasteKoor of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      EditMskG(KoorMaske,OK,rm);
      ClrDskTpG(ActPage);
      KoorInit(KoorMaske.erg,Koor);
      end;
   3: begin
      Message('Select Inputfile Coordinate System');
      GtRdFileNameG(100,100,KoorPfad,KoorRdDatei);
      if not Leer(KoorRdDatei) then begin
                                    LoadMsk(KoorRdDatei,KoorMaske,OK);
                                    KoorInit(KoorMaske.erg,Koor);
                                    end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Coordinate System');
      GtWrFileNameG(100,100,KoorPfad,KoorSvDatei);
      if not Leer(KoorSvDatei) then SaveMsk(KoorSvDatei,KoorMaske,OK);
      ClrDskTpG(ActPage);
      end;
   5: begin
      {if ZchFld=scrn then ZchFld:=hcop else ZchFld:=scrn;
      KeysKoor[5]:=ZchFldStr(ZchFld);
      ZchFldInit;}
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteKoor=10;
 end;


procedure PlotKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPlot,TastePlot);
  case TastePlot of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  PlotHist(Histogr,HistColor,HistLineStyle);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   3: begin
      if not HistogrFertig then begin
                                ErrorMessage('No Histogram available');
                                WaitForReturn;
                                ClrDskTpG(ActPage);
                                end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   GoThru(Histogr,GrenzTab,ClustTab,NewGrenz);
                   case HistType of
                    0: begin ClustTabEig:=ClustTab; ModEigFertig:=True; end;
                    1: begin ClustTabFrm:=ClustTab; ModFrmFertig:=True; end;
                   end;
       WaitForReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   4: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  DsplNvts(ClustTab);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   5: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  PlotApproxFkt(ClustTab);
                  EvalApproxFkt(Histogr,ClustTab,AnzClust,Merr,Rmse);
                  DsplError(AnzClust,Merr,Rmse);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   6: begin
      Message('Determine Widening Factor for Gaussians');
      GetWertR('Widening Factor = ',GlFaktor);
      ClrDsktpG(ActPage);
      end;
   7: begin
      Message('Determine Movement Threshold');
      GetWertR('Movement Threshold = ',WndrgSchw);
      ClrDsktpG(ActPage);
      end;
   8: begin
      Message('Determine Cluster Threshold');
      GetWertR('Cluster Threshold = ',ClustSchw);
      ClrDsktpG(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;

  end;
 until TastePlot=10;
 end;


procedure MainKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysMain,TasteMain);
  case TasteMain of
   1: PlotKeys;
   2: KoorKeys;
   3: DirektKeys;
   4: HistKeys;
   5: ModellKeys;
   6: begin
      Message('Select Outputfile Cluster List');
      GtWrFileNameG(100,100,ClustLstPfad,ClustLstSvDatei);
      if not Leer(ClustLstSvDatei) then WrClustLst(ClustLstSvDatei,ClustTab,GrenzTab);
      ClrDskTpG(ActPage);
      end;
   7: ParamKeys;
   8: begin
      RestoreCrtMode;
      SwapVectors;
      Exec(Editorpfad,'');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      ClrDskTpG(ActPage);
      end;
   9: begin
      w:=DskTpColor[ActPage];
      DskTpColor[ActPage]:=Black;
      ClrDskTpG(ActPage);
      RestoreCrtMode;
      SwapVectors;
      Exec('C:\COMMAND.COM','');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      DskTpColor[ActPage]:=w;
      ClrDskTpG(ActPage);
      end;
  end;
  until TasteMain=10;
 end;


begin
DetectGraph(GrDr,GrMd); GrMd:=1;
DtctGrphPar(ChrW,ChrH,AnzPxH,AnzPxV);
BGIPfad:=GetEnv('BGIPFAD');
InitGraph(GrDr,GrMd,BGIPfad);
MouseReset;

ZchFld:=scrn; {KeysKoor[5]  := ZchFldStr(ZchFld);}   ZchFldInit;
HistType:=2;  KeysHist[5]  :='  BOTH';
              KeysModell[5]:='  BOTH';

ClsLst[1]:='0'; ClsLst[2]:='1';  ClsLst[3]:='2'; KlAnz:=3;
SlctLabel:=ClsLst[1];
ClSlctFromClsLst(ClsLst,KlAnz,ClSlct);
HistFertig:=False;
HistogrFertig:=False;
ModEigFertig:=False;
ModFrmFertig:=False;
HistEigFrmFertig:=False;
HistGlbwFertig:=False;
ClrHist(Histogr);

ClustTab.anz:=0;

BeschrColor:=      White;
ClustSchw:=        3.0;
WndrgSchw:=        1.0;
DsplApp:=          True;  KeysParam[6] :='   APP';
DsplErr:=          True;  KeysParam[7] :='   ERR';
DsplNvt:=          True;  KeysParam[8] :='   NVT';
SnglStp:=          False; KeysParam[9] :='NOSTEP';
DsplOpt:=          False; KeysRandOp[7]:='NO_DSP';
                          KeysGradOp[7]:='NO_DSP';
PrtkOpt:=          False; KeysTools[7] :='NOPRTC';
GlFaktor:=         1.0;
FiltPar:=          2;

ParGlbwMod     :=ParGlbwModInit;
OptStepGrad    :=OptStepGradInit;
OptStepGradMax :=64*OptStepGrad;
SimFakGrad     :=SimFakGradInit;
OptStepRand    :=OptStepRandInit;
SimFakRand     :=SimFakRandInit;
LimitGrad      :=LimitGradInit;

PfadePfad:=  '*.MSK';
PfadeRdDflt:='PFADMDL.MSK';
KoorRdDflt:= 'KOORMDL.MSK';
FarbeRdDflt:='FARBMDL.MSK';


LoadMsk(PfadeRdDflt,PfadeMaske,OK);
 if not OK then WriteXYG(100,100,PfadeRdDflt+' not found')
           else PfadeInitMdl(PfadeMaske);
LoadMsk(KoorRdDatei,KoorMaske,OK);
 if not OK then WriteXYG(100,110,KoorRdDatei+' not found')
           else KoorInit(KoorMaske.erg,Koor);
LoadMsk(FarbeRdDatei,FarbeMaske,OK);
 if not OK then WriteXYG(100,130,FarbeRdDatei+' not found')
           else ColorInitMdl(FarbeMaske);


IncGlbwColor:=True; KeysDirekt[7]:='INCCOL';
AktGlbwColor:=GlbwColor;


ActPage:=1; {Grafikseite}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);
ActPage:=0; {Textseite im Grafikmode}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);

Titel('MDLHST');

while WaitForReturnOrEscape do begin
                               ActPage:=0; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                                           ClrDsktpG(ActPage);
                                           MainKeys;
                               ActPage:=1; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                               end;
Closegraph;
end.
