program PKXe;

{$M 16000,0,30000}


Uses
 graph,dos,crt,
 js_sub,js_acc,js_key,js_tio,js_fio,
 js_koor,js_stm,js_mtr,js_gra,pc_mouse,js_pkx;



Var
 ch:          Char;
 k,m:         Word;
 w:           Word;
 s,sc:        String;


 PfadeMaske: MskPar_T;
 KoorMaske:  MskPar_T;
 FarbeMaske: MskPar_T;

 TasteMain     : FktTst;
  TastePlot    : FktTst;
  TasteKoor    : FktTst;
  TasteHist    : FktTst;
  TastePKX     : FktTst;
  TasteParam   : FktTst;
    TastePfade : FktTst;
    TasteFarbe : FktTst;


Const
 KeysMain:  KeyTxt =('Main',
                     '->PLOT','->COOR','->HIST','-> PKX','      ',
                     'LD_CLF','->PARA','-> EDI','-> DOS','IMGEXT');

 KeysPlot:  KeyTxt =('Plot',
                     '  COOR','  PLOT','......','......','PL_NVT',
                     'PL_CNF','PL_CNV',' IMAGE',' CLEAR','MAIN<-');

 KeysKoor:  KeyTxt =('Coor',
                     '  PLOT','  EDIT','LD_COO','SV_COO','      ',
                     '      ','      ',' IMAGE',' CLEAR','MAIN<-');

 KeysHist:  KeyTxt =('Hist',
                     'MKHIST','      ','LD_HST','SV_HST','      ',
                     '      ','      ','      ','      ','MAIN<-');

 KeysPKX:   KeyTxt =('PKX',
                     'FR_HST','FR_MOM','      ','SV_PKX','      ',
                     '      ','      ','      ','      ','MAIN<-');

 KeysParam: KeyTxt =('Param',
                     '->PATH','->COLS','WCOLOR','WRTIMG','      ',
                     '      ','      ','      ','      ','MAIN<-');

 KeysPfade: KeyTxt =('Path',
                     '      ','  EDIT','LD_PFD','SV_PFD','      ',
                     '      ','      ','      ','      ','PARA<-');

 KeysFarbe: KeyTxt =('Colors',
                     '      ','  EDIT','LD_FRB','SV_FRB','      ',
                     '      ','      ','      ','      ','PARA<-');




procedure PlotKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPlot,TastePlot);
  case TastePlot of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      if not HistFertig then begin
                             ErrorMessage('No Histogram available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetColor(KoorColor);
                   SetVisualPage(ActPage);
                   PlotProConFrmHist(Slct,HistType);
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   3: begin
      HistType:=(Histtype+1) mod 5;
      case HistType of
       0: KeysPlot[3]:='   PRO';
       1: KeysPlot[3]:='   CON';
       2: KeysPlot[3]:='   FRM';
       3: KeysPlot[3]:='PROCON';
       4: KeysPlot[3]:='   ALL';
      end;
      end;
   4: begin
      With ProConLst do
       begin
       Slct:=(Slct+1) mod (anz+1);
       case Slct of
        0:   KeysPlot[4]:='  MEAN';
        else KeysPlot[4]:='  '+dat[Slct].class+'/'+dat[Slct].cmpcl+' ';
       end;
       end;
      end;
   5: begin
      if not ProConFrmModFertig then begin
                                     ErrorMessage('No Pro/Contra/Fremd-Model available');
                                     WaitForReturn;
                                     ClrDskTpG(ActPage);
                                     end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetColor(KoorColor);
                   SetVisualPage(ActPage);
                   PlotNvt(Slct,HistType);
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   6: begin
      if not ProConFrmModFertig then begin
                                     ErrorMessage('No Pro/Contra/Fremd-Model available');
                                     WaitForReturn;
                                     ClrDskTpG(ActPage);
                                     end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetColor(KoorColor);
                   SetVisualPage(ActPage);
                   PlotGlbw(Slct);
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   7: begin
      if not KlfGeladen then begin
                             ErrorMessage('No Classifier available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetColor(KoorColor);
                   SetVisualPage(ActPage);
                   PlotGlbwFromQMS(Slct);
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   8: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
    9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TastePlot=10;
 end;


procedure KoorKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysKoor,TasteKoor);
  case TasteKoor of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      EditMskG(KoorMaske,OK,rm);
      ClrDskTpG(ActPage);
      KoorInit(KoorMaske.erg,Koor);
      end;
   3: begin
      Message('Select Inputfile Coordinate System');
      GtRdFileNameG(100,100,KoorPfad,KoorRdDatei);
      if not Leer(KoorRdDatei) then begin
                                    LoadMsk(KoorRdDatei,KoorMaske,OK);
                                    KoorInit(KoorMaske.erg,Koor);
                                    end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Coordinate System');
      GtWrFileNameG(100,100,KoorPfad,KoorSvDatei);
      if not Leer(KoorSvDatei) then SaveMsk(KoorSvDatei,KoorMaske,OK);
      ClrDskTpG(ActPage);
      end;
   5: begin
      {if ZchFld=scrn then ZchFld:=hcop else ZchFld:=scrn;
      KeysKoor[5]:=ZchFldStr(ZchFld);
      ZchFldInit;}
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteKoor=10;
 end;


procedure HistKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysHist,TasteHist);
  case TasteHist of
   1: begin
      if not KLFGeladen then begin
                             ErrorMessage('No Classifier available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       Message('Select Inputfile Measurement Vectors');
       GtRdFileNameG(100,100,StchpPfad,StchpRdDatei);
       if not Leer(StchpRdDatei) then
        begin
        ProConFrmHistogramm(StchpRdDatei,OK);
        HistFertig:=OK;
        end;
       ClrDskTpG(ActPage);
       end;
      end;
   3: begin
      Message('Select Inputfile Histogram');
      GtRdFileNameG(100,100,HistPfad,HistRdDatei);
      if not Leer(HistRdDatei) then
       begin
       LoadProConFrmHist(HistRdDatei,OK);
       HistFertig:=OK;
       end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      if not HistFertig then begin
                             ErrorMessage('No Histogram available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       Message('Select Outputfile Histogram');
       GtWrFileNameG(100,100,HistPfad,HistSvDatei);
       if not Leer(HistSvDatei) then SaveProConFrmHist(HistSvDatei,OK);
       ClrDskTpG(ActPage);
       end;
      end;
  end;
 until TasteHist=10;
 end;


procedure PKXKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPKX,TastePKX);
  case TastePKX of
   1: begin
      if not HistFertig then begin
                             ErrorMessage('No Histogram available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       ProConFrmModFromHist;
       ProConFrmModFertig:=True;
       end;
      end;
   2: begin
      if not KlfGeladen then begin
                             ErrorMessage('No Classifier available');
                             WaitForReturn;
                             end
      else if KlfDat.typ<>'PKL' then begin
                                     ErrorMessage('No PKL-Classifier');
                                     WaitForReturn;
                                     end
      else
       begin
       Message('Select Inputfile Recipe');
       GtRdFileNameG(100,100,RzpPfad,RzpRdDatei);
       if not Leer(RzpRdDatei) then
        begin
        LoadRezept(RzpRdDatei,RzpDat,OK);
        if OK then begin
                   ProConFrmModFromMom(RzpDat,MomPfad,KlfDat,OK);
                   ProConFrmModFertig:=True;
                   end;
        end;
       end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      if not ProConFrmModFertig then begin
                                     ErrorMessage('No Eigen/Fremd-Model available');
                                     WaitForReturn;
                                     ClrDskTpG(ActPage);
                                     end
      else if not KLFGeladen    then begin
                                     ErrorMessage('No Classifier available');
                                     WaitForReturn;
                                     ClrDskTpG(ActPage);
                                     end
      else
       begin
       KmplKlfPKL(KlfDat);
       Message('Select Outputfile PKX-Classifier');
       GtWrFileNameG(100,100,KlfPfad,KlfSvDatei);
       if not Leer(KlfSvDatei) then SaveKlf(KlfSvDatei,KlfDat,OK);
       ClrDskTpG(ActPage);
       end;
      end;
  end;
 until TastePKX=10;
 end;


procedure PfadeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPfade,TastePfade);
  case TastePfade of
   2: begin
      EditMskG(PfadeMaske,OK,rm);
      PfadeInitPKX(PfadeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Paths and Defaults');
      GtRdFileNameG(100,100,PfadePfad,PfadeRdDatei);
      if not Leer(PfadeRdDatei) then begin
                                     LoadMsk(PfadeRdDatei,PfadeMaske,OK);
                                     PfadeInitPKX(PfadeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Paths and Defaults');
      GtWrFileNameG(100,100,PfadePfad,PfadeSvDatei);
      if not Leer(PfadeSvDatei) then SaveMsk(PfadeSvDatei,PfadeMaske,OK);
      ClrDskTpG(ActPage);
      end;
  end;
 until TastePfade=10;
 end;


procedure FarbeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysFarbe,TasteFarbe);
  case TasteFarbe of
   2: begin
      EditMskG(FarbeMaske,OK,rm);
      ColorInitPKX(FarbeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Presentation Parameters');
      GtRdFileNameG(100,100,FarbePfad,FarbeRdDatei);
      if not Leer(FarbeRdDatei) then begin
                                     LoadMsk(FarbeRdDatei,FarbeMaske,OK);
                                     ColorInitPKX(FarbeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Presentation Parameters');
      GtWrFileNameG(100,100,FarbePfad,FarbeSvDatei);
      if not Leer(FarbeSvDatei) then SaveMsk(FarbeSvDatei,FarbeMaske,OK);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteFarbe=10;
 end;


procedure ParamKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysParam,TasteParam);
  case TasteParam of
   1: PfadeKeys;
   2: FarbeKeys;
   3: begin
      repeat
       s:=ColorToStr(BeschrColor);
       OvWrt:=True;
       GetStr('Color for Writing Text in Image: ',12,s);
       BeschrColor:=ColorFromStr(s);
      until BeschrColor<=15;
      ClrDskTpG(ActPage);
      end;
   4: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  TextColor(BeschrColor);
                  TextBackGround(DsktpColor[ActPage]);
                  Beschrifte;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteParam=10;
 end;


procedure MainKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysMain,TasteMain);
  case TasteMain of
   1: PlotKeys;
   2: KoorKeys;
   3: HistKeys;
   4: PKXKeys;
   6: begin
      Message('Select Inputfile PKL-Classifier');
      GtRdFileNameG(100,100,KlfPfad,KlfRdDatei);
      if not Leer(KlfRdDatei) then
        begin
        LoadKlf(KlfRdDatei,KlfDat,OK);
        KlfGeladen:=OK;
        ProConLstFromKlfDat(KlfDat,ProConLst);
        Slct:=0; KeysPlot[4]:='MITTEL';
        ClSlctFromProConLst(ProConLst,KlAnz,ClSlct);
        end;
      ClrDskTpG(ActPage);
      end;
   7: ParamKeys;
   8: begin
      RestoreCrtMode;
      SwapVectors;
      Exec(Editorpfad,'');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      ClrDskTpG(ActPage);
      end;
   9: begin
      w:=DskTpColor[ActPage];
      DskTpColor[ActPage]:=Black;
      ClrDskTpG(ActPage);
      RestoreCrtMode;
      SwapVectors;
      Exec('C:\COMMAND.COM','');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      DskTpColor[ActPage]:=w;
      ClrDskTpG(ActPage);
      end;
   end;
  until TasteMain=10;
 end;



begin
DetectGraph(GrDr,GrMd); GrMd:=1;
DtctGrphPar(ChrW,ChrH,AnzPxH,AnzPxV);
BGIPfad:=GetEnv('BGIPFAD');
InitGraph(GrDr,GrMd,BGIPfad);
MouseReset;

PfadePfad:=  '*.MSK';
PfadeRdDflt:='PFADPKX.MSK';
KoorRdDflt:= 'KOORPKX.MSK';
FarbeRdDflt:='FARBPKX.MSK';

LoadMsk(PfadeRdDflt,PfadeMaske,OK);
 if not OK then WriteXYG(100,100,PfadeRdDflt+' not found')
           else PfadeInitPKX(PfadeMaske);
LoadMsk(KoorRdDatei,KoorMaske,OK);
 if not OK then WriteXYG(100,110,KoorRdDatei+' not found')
           else KoorInit(KoorMaske.erg,Koor);
LoadMsk(FarbeRdDatei,FarbeMaske,OK);
 if not OK then WriteXYG(100,130,FarbeRdDatei+' not found')
           else ColorInitPKX(FarbeMaske);


ZchFld:=scrn; {KeysKoor[5]:= ZchFldStr(ZchFld);} ZchFldInit;
HistType:=4; KeysPlot[3]:='   ALL';
ClrProConLst;
Slct:=0; KeysPlot[4]:='  MEAN';
ClrProConFrmHist;
HistFertig:=False;
ProConFrmModFertig:=False;
KlfGeladen:=False;
BeschrColor:=White;


ActPage:=1; {Grafikseite}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);
ActPage:=0; {Textseite im Grafikmode}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);

Titel('PKL -> PKX');

while WaitForReturnOrEscape do begin
                               ActPage:=0; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                                           ClrDsktpG(ActPage);
                                           MainKeys;
                               ActPage:=1; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                               end;
Closegraph;
end.