program QMXe;

{$M 32768,0,100000}


Uses
 graph,dos,crt,
 js_sub,js_acc,js_key,js_tio,js_fio,
 js_koor,js_stm,js_mtr,js_gra,pc_mouse,js_qmx,
 matrix,js_zepas;



Var
 ch:          Char;
 k:           Word;
 w:           Word;
 s,sc:        String;


 PfadeMaske: MskPar_T;
 KoorMaske:  MskPar_T;
 FarbeMaske: MskPar_T;

 TasteMain     : FktTst;
  TastePlot    : FktTst;
  TasteKoor    : FktTst;
  TasteHist    : FktTst;
  TasteQMX     : FktTst;
  TasteParam   : FktTst;
    TastePfade : FktTst;
    TasteFarbe : FktTst;


Const
 KeysMain:  KeyTxt =('Main',
                     '->PLOT','->COOR','->HIST','-> QMX','      ',
                     'LD_CLF','->PARA','-> EDI','-> DOS','IMGEXT');

 KeysPlot:  KeyTxt =('Plot',
                     '  COOR','  PLOT','......','SELECT','      ',
                     'PL_NVT','PL_CNF',' IMAGE',' CLEAR','MAIN<-');

 KeysKoor:  KeyTxt =('Coor',
                     '  PLOT','  EDIT','LD_COO','SV_COO','      ',
                     '      ','      ',' IMAGE',' CLEAR','MAIN<-');

 KeysHist:  KeyTxt =('Hist',
                     'MKHIST','CL_LST','LD_HST','SV_HST','      ',
                     '......','      ','      ','      ','MAIN<-');

 KeysQMX:   KeyTxt =('QMX',
                     'FR_HST','FR_MOM','      ','SV_QMX','      ',
                     '      ','      ','      ','      ','MAIN<-');

 KeysParam: KeyTxt =('Param',
                     '->PATH','->COLS','WCOLOR','WRTIMG','      ',
                     '      ','......','......','      ','MAIN<-');

 KeysPfade: KeyTxt =('Paths',
                     '      ','  EDIT','LD_PFD','SV_PFD','      ',
                     '......','      ','      ','      ','PARA<-');

 KeysFarbe: KeyTxt =('Colors',
                     '      ','  EDIT','LD_FRB','SV_FRB','      ',
                     '      ','      ','      ','      ','PARA<-');




procedure PlotKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPlot,TastePlot);
  case TastePlot of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      if not HistFertig then begin
                             ErrorMessage('No Histogram available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   PlotEigFrmHist(SlctLabel,HistType);
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   3: begin
      HistType:=(Histtype+1) mod 3;
      case HistType of
       0: KeysPlot[3]:=' EIGEN';
       1: KeysPlot[3]:=' FREMD';
       2: KeysPlot[3]:='  BOTH';
      end;
      end;
   4: begin
      s:=''; for k:=1 to KlAnz do s:=s+ClsLst[k]+' ';
      Message('Label from '+s+'or SpaceBar');
      s:=SlctLabel;
      repeat
       GetStr('Class Label : ',1,s);
       SlctLabel:=s[1];
      until SlctLabel in (ClSlct+[#32]);
      ClrDskTpG(ActPage);
      end;
   6: begin
      if not EigFrmModFertig then begin
                                  ErrorMessage('No Eigen/Fremd-Model available');
                                  WaitForReturn;
                                  ClrDskTpG(ActPage);
                                  end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetColor(KoorColor);
                   SetVisualPage(ActPage);
                   PlotNvt(SlctLabel,HistType);
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   7: begin
      if not EigFrmModFertig then begin
                                  ErrorMessage('No Eigen/Fremd-Model available');
                                  WaitForReturn;
                                  ClrDskTpG(ActPage);
                                  end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetColor(KoorColor);
                   SetVisualPage(ActPage);
                   PlotGlbw(SlctLabel);
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   8: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
    9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TastePlot=10;
 end;


procedure KoorKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysKoor,TasteKoor);
  case TasteKoor of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      EditMskG(KoorMaske,OK,rm);
      ClrDskTpG(ActPage);
      KoorInit(KoorMaske.erg,Koor);
      end;
   3: begin
      Message('Select Inputfile Coordinate System');
      GtRdFileNameG(100,100,KoorPfad,KoorRdDatei);
      if not Leer(KoorRdDatei) then begin
                                    LoadMsk(KoorRdDatei,KoorMaske,OK);
                                    KoorInit(KoorMaske.erg,Koor);
                                    end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Coordinate System');
      GtWrFileNameG(100,100,KoorPfad,KoorSvDatei);
      if not Leer(KoorSvDatei) then SaveMsk(KoorSvDatei,KoorMaske,OK);
      ClrDskTpG(ActPage);
      end;
   5: begin
      {if ZchFld=scrn then ZchFld:=hcop else ZchFld:=scrn;
      KeysKoor[5]:=ZchFldStr(ZchFld);
      ZchFldInit;}
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteKoor=10;
 end;


procedure HistKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysHist,TasteHist);
  case TasteHist of
   1: begin
      if SrcDVekt then begin
                       Message('Select Inputfile Discriminant Vectors');
                       GtRdFileNameG(100,100,DvektPfad,RdDatei);
                       end
                  else begin
                       Message('Select Inputfile Measurement Vectors');
                       GtRdFileNameG(100,100,StchpPfad,RdDatei);
                       end;
      if not Leer(RdDatei) then
       begin
       EigFrmHistogramm(RdDatei,OK);
       HistFertig:=OK;
       end;
      ClrDskTpG(ActPage);
      end;
    2: begin
      Message('Determine Set of Class Labels');
      s:=''; for k:=1 to KlAnz do s:=s+ClsLst[k]+' ';
      OvWrt:=True;
      GetStr('List of Class Labels : ',50,s);
      GetPar(s); KlAnz:=ParCount;
      for k:=1 to KlAnz do begin sc:=ParStr(k); ClsLst[k]:=sc[1]; end;
      ClSlctFromClsLst(ClsLst,KlAnz,ClSlct);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Histogram');
      GtRdFileNameG(100,100,HistPfad,HistRdDatei);
      if not Leer(HistRdDatei) then
       begin
       LoadEigFrmHist(HistRdDatei,OK);
       ClSlctFromClsLst(ClsLst,KlAnz,ClSlct);
       SlctLabel:=ClsLst[1];
       HistFertig:=OK;
       end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      if not HistFertig then begin
                             ErrorMessage('No Histogram available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       Message('Select Outputfile Histogram');
       GtWrFileNameG(100,100,HistPfad,HistSvDatei);
       if not Leer(HistSvDatei) then SaveEigFrmHist(HistSvDatei,OK);
       ClrDskTpG(ActPage);
       end;
      end;
   6: begin
      if not KLFGeladen then begin
                             ErrorMessage('No Classifier available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else begin
           SrcDVekt:=not SrcDVekt;
           if SrcDVekt then KeysHist[6]:='D_VECTOR'
                       else KeysHist[6]:='V_VECTOR';
           end;
      end;
  end;
 until TasteHist=10;
 end;


procedure QMXKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysQMX,TasteQMX);
  case TasteQMX of
   1: begin
      if not HistFertig then begin
                             ErrorMessage('No Histogramm available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       EigFrmModFromHist;
       EigFrmModFertig:=True;
       end;
      end;
   2: begin
      if not KlfGeladen then begin
                             ErrorMessage('No Classifier available');
                             WaitForReturn;
                             end
      else if KlfDat.typ<>'QMK' then begin
                                     ErrorMessage('No QMK-Classifier');
                                     WaitForReturn;
                                     end
      else
       begin
       Message('Select Inputfile Recipe');
       GtRdFileNameG(100,100,RzpPfad,RzpRdDatei);
       if not Leer(RzpRdDatei) then
        begin
        LoadRezept(RzpRdDatei,RzpDat,OK);
        if OK then begin
                   EigFrmModFromMom(RzpDat,MomPfad,KlfDat,OK);
                   EigFrmModFertig:=True;
                   end;
        end;
       end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      if not EigFrmModFertig then begin
                                  ErrorMessage('No Eigen/Fremd-Model available');
                                  WaitForReturn;
                                  ClrDskTpG(ActPage);
                                  end
      else
       begin
       KmplKlf(KlfDat);
       Message('Selct Outputfile QMX-Classifier');
       GtWrFileNameG(100,100,KlfPfad,KlfSvDatei);
       if not Leer(KlfSvDatei) then SaveKlf(KlfSvDatei,KlfDat,OK);
       ClrDskTpG(ActPage);
       end;
      end;
  end;
 until TasteQMX=10;
 end;


procedure PfadeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPfade,TastePfade);
  case TastePfade of
   2: begin
      EditMskG(PfadeMaske,OK,rm);
      PfadeInitQMX(PfadeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Paths and Defaults');
      GtRdFileNameG(100,100,PfadePfad,PfadeRdDatei);
      if not Leer(PfadeRdDatei) then begin
                                     LoadMsk(PfadeRdDatei,PfadeMaske,OK);
                                     PfadeInitQMX(PfadeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Paths and Defaults');
      GtWrFileNameG(100,100,PfadePfad,PfadeSvDatei);
      if not Leer(PfadeSvDatei) then SaveMsk(PfadeSvDatei,PfadeMaske,OK);
      ClrDskTpG(ActPage);
      end;
   6: begin
      {if RdbTyp=clcprb then RdbTyp:=apoprb else RdbTyp:=Succ(RdbTyp);
      case RdbTyp of
       apoprb: KeysPfade[6]:='APOPRB';
       clcprb: KeysPfade[6]:='CLCPRB';
      end;}
      end;
  end;
 until TastePfade=10;
 end;


procedure FarbeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysFarbe,TasteFarbe);
  case TasteFarbe of
   2: begin
      EditMskG(FarbeMaske,OK,rm);
      ColorInitQMX(FarbeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Presemtation Parameters');
      GtRdFileNameG(100,100,FarbePfad,FarbeRdDatei);
      if not Leer(FarbeRdDatei) then begin
                                     LoadMsk(FarbeRdDatei,FarbeMaske,OK);
                                     ColorInitQMX(FarbeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Representation Parameters');
      GtWrFileNameG(100,100,FarbePfad,FarbeSvDatei);
      if not Leer(FarbeSvDatei) then SaveMsk(FarbeSvDatei,FarbeMaske,OK);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteFarbe=10;
 end;


procedure ParamKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysParam,TasteParam);
  case TasteParam of
   1: PfadeKeys;
   2: FarbeKeys;
   3: begin
      repeat
       s:=ColorToStr(BeschrColor);
       OvWrt:=True;
       GetStr('Color for Writing Text in Image: ',12,s);
       BeschrColor:=ColorFromStr(s);
      until BeschrColor<=15;
      ClrDskTpG(ActPage);
      end;
   4: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  TextColor(BeschrColor);
                  TextBackGround(DsktpColor[ActPage]);
                  Beschrifte;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   7: begin
      {if ModeKlf=zep then ModeKlf:=stm else ModeKlf:=zep;
      case ModeKlf of
       stm: KeysParam[7]:='MD_KLF';
       zep: KeysParam[7]:='MD_ZEP';
      end;
      RadBas:=False; KeysParam[8]:='NO_RDB';}
      end;
   8: begin
      {If (ModeKlf=zep) and not RadBas then RadBas:=True else RadBas:=False;
      if RadBas then begin
                     KeysParam[8]:='   RDB';
                     Message('Eingabe Aufweitungsfaktor RdbFak');
                     GetWertR('RdbFak: ',RdbFak);
                     ClrDskTpG(ActPage);
                     end
                else KeysParam[8]:='NO_RDB';}
      end;
   9: begin
      {Message('Auswahl Zepas-RadBas-Eingabedatei');
      GtRdFileNameG(100,100,ZRdbPfad,ZRdbRdDatei);
      if not Leer(ZRdbRdDatei) then
       begin
       if ZRdbDatFertig then dispose(RdbDat,done);
       RdbDat:=New(RdbDat_P,InitLoad(ZRdbRdDatei,RdbFak));
       ZRdbDatFertig:=True;
       end;
      ClrDskTpG(ActPage);}
      end;
  end;
 until TasteParam=10;
 end;


procedure MainKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysMain,TasteMain);
  case TasteMain of
   1: PlotKeys;
   2: KoorKeys;
   3: HistKeys;
   4: QMXKeys;
   6: begin
      case ModeKlf of
       stm: begin
            Message('Select Inputfile Classifier');
            GtRdFileNameG(100,100,KlfPfad,KlfRdDatei);
            if not Leer(KlfRdDatei) then
             begin
             LoadKlf(KlfRdDatei,KlfDat,OK);
             ClsLstFromKlfDat(KlfDat,ClsLst,Klanz);
             ClSlctFromClsLst(ClsLst,Klanz,ClSlct);
             SlctLabel:=ClsLst[1];
             KlfGeladen:=OK;
             end;
            end;
       {zep: begin
            Message('Auswahl Zepas-Klassifikator-Eingabedatei');
            GtRdFileNameG(100,100,ZKlfPfad,ZKlfRdDatei);
            if not Leer(ZKlfRdDatei) then
             begin
             if Koeff<>Nil then dispose(Koeff,done);
             Klf:=new(ClfDat_P,InitLoad(ZKlfRdDatei));
               Psl:=   Klf^.PslDat;
               Klanz:= Klf^.Matrix^.col;
               for k:=1 to Klanz do ClsLst[k]:=Klf^.Classes[k];
               Koeff:=new(PMatrix,InitCopy(Klf^.Matrix));
               Koeff^.Transpose;
             dispose(Klf,done);

             if Radbas then
                begin
                if not ZRdbDatFertig then
                  begin
                  ErrorMessage('RdbDat fehlt');
                  WaitForReturn;
                  end
                 else
                  begin
                  if Psl.LengthMv<>RdbDat^.LengthPv then
                   begin
                   ErrorMessage('Klassifikator pat nicht zu RdbDat');
                   ZKlfDatFertig:=False;
                   WaitForReturn;
                   end
                  else
                   begin
                   ZKlfDatFertig:=True;
                   KlfGeladen:=True;
                   end;
                  end;
                end
              else
                begin
                if Psl.LengthMv<>2 then
                   begin
                   ErrorMessage('Klassifikator ist nicht fr dim[v]=2');
                   ZKlfDatFertig:=False;
                   WaitForReturn;
                   end
                  else
                   begin
                   ZKlfDatFertig:=True;
                   KlfGeladen:=True;
                   end;
                end;

             CnfMap:=False; KeysParam[5]:='NO_CNF';
             ClSlctFromClsLst(ClsLst,Klanz,ClSlct);
             SlctLabel:=ClsLst[1];
             end;
            end;}
      end;
      ClrDskTpG(ActPage);
      end;
   7: ParamKeys;
   8: begin
      RestoreCrtMode;
      SwapVectors;
      Exec(Editorpfad,'');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      ClrDskTpG(ActPage);
      end;
   9: begin
      w:=DskTpColor[ActPage];
      DskTpColor[ActPage]:=Black;
      ClrDskTpG(ActPage);
      RestoreCrtMode;
      SwapVectors;
      Exec('C:\COMMAND.COM','');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      DskTpColor[ActPage]:=w;
      ClrDskTpG(ActPage);
      end;
   end;
  until TasteMain=10;
 end;



begin
DetectGraph(GrDr,GrMd); GrMd:=1;
DtctGrphPar(ChrW,ChrH,AnzPxH,AnzPxV);
BGIPfad:=GetEnv('BGIPFAD');
InitGraph(GrDr,GrMd,BGIPfad);
MouseReset;

PfadePfad:=  '*.MSK';
PfadeRdDflt:='PFADQMX.MSK';
KoorRdDflt:= 'KOORQMX.MSK';
FarbeRdDflt:='FARBQMX.MSK';

LoadMsk(PfadeRdDflt,PfadeMaske,OK);
 if not OK then WriteXYG(100,100,PfadeRdDflt+' not found')
           else PfadeInitQMX(PfadeMaske);
LoadMsk(KoorRdDatei,KoorMaske,OK);
 if not OK then WriteXYG(100,110,KoorRdDatei+' not found')
           else KoorInit(KoorMaske.erg,Koor);
LoadMsk(FarbeRdDatei,FarbeMaske,OK);
 if not OK then WriteXYG(100,130,FarbeRdDatei+' not found')
           else ColorInitQMX(FarbeMaske);


ZchFld:=scrn; {KeysKoor[5]:= ZchFldStr(ZchFld);} ZchFldInit;
HistType:=2; KeysPlot[3]:='  BOTH';
ClsLst[1]:='0'; ClsLst[2]:='1';  ClsLst[3]:='2'; KlAnz:=3;
SlctLabel:=ClsLst[1];
ClSlctFromClsLst(ClsLst,KlAnz,ClSlct);
DVektRdDatei:='';
ClrEigFrmHist;
OutlSchw:=10;
RadqSchw:=4.0;
HistFertig:=False;
EigFrmModFertig:=False;
KlfGeladen:=False;
ZKlfDatFertig:=False;
ZRdbDatFertig:=False;
RdbFak:=1.0;
BeschrColor:=White;

SrcDvekt:=True;    KeysHist[6] :='D_VEKT';
ModeKlf:=stm;      KeysParam[7]:='      ';
RadBas:=False;     KeysParam[8]:='      ';
RdbTyp:=apoprb;    KeysPfade[6]:='      ';



ActPage:=1; {Grafikseite}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);
ActPage:=0; {Textseite im Grafikmode}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);

Titel('QMK -> QMX');

while WaitForReturnOrEscape do begin
                               ActPage:=0; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                                           ClrDsktpG(ActPage);
                                           MainKeys;
                               ActPage:=1; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                               end;

if ZKlfDatFertig then dispose(Koeff,done);
if ZRdbDatFertig then dispose(RdbDat,done);
Closegraph;
end.