program CLUSTe;

{$M 16000,0,40000}


Uses
 graph,dos,crt,
 js_sub,js_acc,js_key,js_tio,js_fio,js_koor,js_stm,js_mtr,js_gra,pc_mouse,js_clust;

Var
 ch:         Char;
 w:          Word;
 i,j:        Integer;
 wert:       Real;
 s:          String;


 PfadeMaske: MskPar_T;
 KoorMaske:  MskPar_T;
 FarbeMaske: MskPar_T;

 SumTab:     SumTab_T;
 ClustTab:   ClustTab_T;
 RefTab:     RefTab_T;
 NewRef:     RefTab_T;
 StMod:      StMod_T;


 TasteMain     : FktTst;
   TastePlot   : FktTst;
   TasteKoor   : FktTst;
   TasteStchp  : FktTst;
   TasteParam  : FktTst;
     TastePfade: FktTst;
     TasteFarbe: FktTst;


Const
 KeysMain:  KeyTxt =('Main',
                     '->PLOT','->COOR','......','->SMPL','SV_CLS',
                     'SV_STM','->PARA','-> EDI','-> DOS','IMGEXT');

 KeysPlot:  KeyTxt =('Plot',
                     '  COOR','SAMPLE',' CLUST','  ELLI',' LABEL',
                     'DENSTH','MOVETH','CLSTTH',' CLEAR','MAIN<-');

 KeysKoor:  KeyTxt =('Coor',
                     '  PLOT','  EDIT','LD_COO','SV_COO','      ',
                     '      ','      ',' IMAGE',' CLEAR','MAIN<-');

 KeysStchp: KeyTxt =('Sample',
                     '  COOR','      ','RDSMPL','  PLOT',' STARS',
                     'MAXSTP','      ',' IMAGE',' CLEAR','MAIN<-');

 KeysParam: KeyTxt =('Param',
                     '->PATH','->COLS','WCOLOR','WRTIMG','SELECT',
                     '......','......','......','......','MAIN<-');

 KeysPfade: KeyTxt =('Paths',
                     '      ','  EDIT','LD_PFD','SV_PFD','      ',
                     '      ','      ','      ','      ','PARA<-');

 KeysFarbe: KeyTxt =('Colors',
                     '      ','  EDIT','LD_FRB','SV_FRB','      ',
                     '      ','      ','      ','      ','PARA<-');




procedure PfadeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPfade,TastePfade);
  case TastePfade of
   2: begin
      EditMskG(PfadeMaske,OK,rm);
      PfadeInitClu(PfadeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Paths and Defaults');
      GtRdFileNameG(100,100,PfadePfad,PfadeRdDatei);
      if not Leer(PfadeRdDatei) then begin
                                     LoadMsk(PfadeRdDatei,PfadeMaske,OK);
                                     PfadeInitClu(PfadeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Paths and Defaults');
      GtWrFileNameG(100,100,PfadePfad,PfadeSvDatei);
      if not Leer(PfadeSvDatei) then SaveMsk(PfadeSvDatei,PfadeMaske,OK);
      ClrDskTpG(ActPage);
      end;
  end;
 until TastePfade=10;
 end;


procedure FarbeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysFarbe,TasteFarbe);
  case TasteFarbe of
   2: begin
      EditMskG(FarbeMaske,OK,rm);
      ColorInitClu(FarbeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Presentation Parameters');
      GtRdFileNameG(100,100,FarbePfad,FarbeRdDatei);
      if not Leer(FarbeRdDatei) then begin
                                     LoadMsk(FarbeRdDatei,FarbeMaske,OK);
                                     ColorInitClu(FarbeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Presentation Parameters');
      GtWrFileNameG(100,100,FarbePfad,FarbeSvDatei);
      if not Leer(FarbeSvDatei) then SaveMsk(FarbeSvDatei,FarbeMaske,OK);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteFarbe=10;
 end;


procedure ParamKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysParam,TasteParam);
  case TasteParam of
   1: PfadeKeys;
   2: FarbeKeys;
   3: begin
      repeat
       s:=ColorToStr(BeschrColor);
       OvWrt:=True;
       GetStr('Color for Writing Text in Image: ',12,s);
       BeschrColor:=ColorFromStr(s);
      until BeschrColor<=15;
      ClrDskTpG(ActPage);
      end;
   4: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  TextColor(BeschrColor);
                  TextBackGround(DsktpColor[ActPage]);
                  Beschrifte;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   5: begin
      Message('Selection of Classes');
      s:=SetToStr(ClSlct);
      GetStr('Select : ',50,s);
      SetFromStr(s,ClSlct);
      ClrDskTpG(ActPage);
      end;
   6: begin
      DsplLabel:=not DsplLabel;
      if DsplLabel then KeysParam[6]:='  LABL'
                   else KeysParam[6]:='NOLABL';
      end;
   7: begin
      DsplTree:=not DsplTree;
      if DsplTree  then KeysParam[7]:='  TREE'
                   else KeysParam[7]:='NOTREE';
      end;
   8: begin
      DsplElli:=not DsplElli;
      if DsplElli  then KeysParam[8]:='  ELLI'
                   else KeysParam[8]:='NOELLI';
      end;
   9: begin
      SnglStp:=not SnglStp;
      if SnglStp   then KeysParam[9]:='  STEP'
                   else KeysParam[9]:='NOSTEP';
      end;
  end;
 until TasteParam=10;
 end;



procedure StchpKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysStchp,TasteStchp);
  case TasteStchp of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   3: begin
      Message('Select Inputfile Sample');
      GtRdFileNameG(100,100,StchpPfad,StchpRdDatei);
      ClrDskTpG(ActPage);
      end;
   4: begin
      if Leer(StchpRdDatei) then
       begin
       ErrorMessage('No Inputfile available');
       WaitforReturn;
       ClrDskTpG(ActPage);
       end
      else
       begin
       Assign(StchpRdFile,StchpRdDatei);
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   ShowStchp;
                   Close(StchpRdFile);
       WaitforReturn;
       end;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   5: begin
      if Leer(StchpRdDatei) then
       begin
       ErrorMessage('No Inputfile available');
       WaitforReturn;
       ClrDskTpG(ActPage);
       end
      else
       begin
       Assign(StchpRdFile,StchpRdDatei);
       ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ShowStars(ClustTab);
                  Close(StchpRdFile);
       WaitforReturn;
       end;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   6: begin
      Message('Determine Stopping Criterion Maximum Number of Cycles');
      GetWertW('MaxNumbCycles = ',MaxSteps);
      ClrDsktpG(ActPage);
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteStchp=10;
 end;



procedure KoorKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysKoor,TasteKoor);
  case TasteKoor of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      EditMskG(KoorMaske,OK,rm);
      ClrDskTpG(ActPage);
      KoorInit(KoorMaske.erg,Koor);
      end;
   3: begin
      Message('Select Inputfile Coordinate System');
      GtRdFileNameG(100,100,KoorPfad,KoorRdDatei);
      if not Leer(KoorRdDatei) then begin
                                    LoadMsk(KoorRdDatei,KoorMaske,OK);
                                    KoorInit(KoorMaske.erg,Koor);
                                    end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Coordinate System');
      GtWrFileNameG(100,100,KoorPfad,KoorSvDatei);
      if not Leer(KoorSvDatei) then SaveMsk(KoorSvDatei,KoorMaske,OK);
      ClrDskTpG(ActPage);
      end;
   5: begin
      {if ZchFld=scrn then ZchFld:=hcop else ZchFld:=scrn;
      KeysKoor[5]:=ZchFldStr(ZchFld);
      ZchFldInit;}
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteKoor=10;
 end;


procedure PlotKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPlot,TastePlot);
  case TastePlot of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      if Leer(StchpRdDatei) then
       begin
       ErrorMessage('No Inputfile available');
       WaitforReturn;
       ClrDskTpG(ActPage);
       end
      else
       begin
       Assign(StchpRdFile,StchpRdDatei);
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   ShowStchp;
                   Close(StchpRdFile);
       WaitforReturn;
       end;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   3: begin
      if Leer(StchpRdDatei) then
       begin
       ErrorMessage('No Inputfile available');
       WaitforReturn;
       ClrDskTpG(ActPage);
       end
      else
       begin
       Assign(StchpRdFile,StchpRdDatei);
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   GoThruStchp(RefTab,SumTab,ClustTab,NewRef);
                   Close(StchpRdFile);
       WaitforReturn;
       end;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   4: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  DsplEllipsen(ClustTab);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   5: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  MarkCen(ClustTab);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   6: begin
      Message('Determine Minimum Density Threshold');
      GetWertR('Minimum Density = ',SlctSchw);
      ClrDsktpG(ActPage);
      end;
    7: begin
      Message('Determine Movement Threshold');
      GetWertR('Movement Threshold = ',WndrgSchw);
      ClrDsktpG(ActPage);
      end;
   8: begin
      Message('Determine Cluster Threshold');
      GetWertR('Cluster Threshold = ',ClustSchw);
      ClrDsktpG(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;

  end;
 until TastePlot=10;
 end;


procedure MainKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysMain,TasteMain);
  case TasteMain of
   1: PlotKeys;
   2: KoorKeys;
   3: begin
      SeedEigVek:=not SeedEigVek;
      if SeedEigVek then KeysMain[3]:='  EIGV'
                    else KeysMain[3]:='NOEIGV';
      end;
   4: StchpKeys;
   5: begin
      Message('Select Outputfile Cluster List');
      GtWrFileNameG(100,100,ClustPfad,ClustSvDatei);
      if not Leer(ClustSvDatei) then WrClustTab(ClustSvDatei,ClustTab);
      ClrDskTpG(ActPage);
      end;
   6: begin
      Message('Select Outputfile Statistical Model');
      GtWrFileNameG(100,100,StModPfad,StModSvDatei);;
      if not Leer(StModSvDatei) then begin
                                     GenStMod(ClustTab,StMod);
                                     SaveStMod(StModSvDatei,StMod,OK);
                                     end;
      ClrDskTpG(ActPage);
      end;
   7: ParamKeys;
   8: begin
      RestoreCrtMode;
      SwapVectors;
      Exec(Editorpfad,'');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      ClrDskTpG(ActPage);
      end;
   9: begin
      w:=DskTpColor[ActPage];
      DskTpColor[ActPage]:=Black;
      ClrDskTpG(ActPage);
      RestoreCrtMode;
      SwapVectors;
      Exec('C:\COMMAND.COM','');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      DskTpColor[ActPage]:=w;
      ClrDskTpG(ActPage);
      end;
  end;
  until TasteMain=10;
 end;


begin
DetectGraph(GrDr,GrMd); GrMd:=1;
DtctGrphPar(ChrW,ChrH,AnzPxH,AnzPxV);
BGIPfad:=GetEnv('BGIPFAD');
InitGraph(GrDr,GrMd,BGIPfad);
MouseReset;

ZchFld:=scrn; {KeysKoor[5]:= ZchFldStr(ZchFld);}   ZchFldInit;
PltSmpl:=1;

ClSlct:=           [];
BeschrColor:=      White;
ClustSchw:=        1.0;
WndrgSchw:=        0.05;
SlctSchw:=         20.0;
DsplLabel:=        False; KeysParam[6]:='NOLABL';
DsplTree:=         True;  KeysParam[7]:='  TREE';
DsplElli:=         True;  KeysParam[8]:='  ELLI';
SnglStp:=          False; KeysParam[9]:='NOSTEP';
SeedEigVek:=       True;  KeysMain[3] :='  EIGV';
MaxSteps:=20;

ClustTab.Anz:=0;

PfadePfad:=  '*.MSK';
PfadeRdDflt:='PFADCLU.MSK';
KoorRdDflt:= 'KOORCLU.MSK';
FarbeRdDflt:='FARBCLU.MSK';


LoadMsk(PfadeRdDflt,PfadeMaske,OK);
 if not OK then WriteXYG(100,100,PfadeRdDflt+' not found')
           else PfadeInitClu(PfadeMaske);
LoadMsk(KoorRdDatei,KoorMaske,OK);
 if not OK then WriteXYG(100,110,KoorRdDatei+' not found')
           else KoorInit(KoorMaske.erg,Koor);
LoadMsk(FarbeRdDatei,FarbeMaske,OK);
 if not OK then WriteXYG(100,130,FarbeRdDatei+' not found')
           else ColorInitClu(FarbeMaske);


ActPage:=1; {Grafikseite}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);
ActPage:=0; {Textseite im Grafikmode}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);

Titel('CLUST');

while WaitForReturnOrEscape do begin
                               ActPage:=0; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                                           ClrDsktpG(ActPage);
                                           MainKeys;
                               ActPage:=1; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                               end;
Closegraph;
end.
