program DCSP;

{$M 32768,0,100000}


Uses
 graph,dos,crt,
 js_sub,js_acc,js_key,js_tio,js_fio,
 js_koor,js_stm,js_mtr,js_gra,pc_mouse,js_dcsp,js_nnt,
 matrix,js_zepas;



Var
 ch:          Char;
 k:           Word;
 w:           Word;
 v:           Vector_2;
 s,sc:        String;
 f:           Text;


 PfadeMaske: MskPar_T;
 KoorMaske:  MskPar_T;
 FarbeMaske: MskPar_T;

 TasteMain     : FktTst;
  TastePlot    : FktTst;
  TasteParam   : FktTst;
    TastePfade : FktTst;
    TasteFarbe : FktTst;


Const
 KeysMain:  KeyTxt =('Main',
                     '->PLOT','......','RD_DAT','SELECT','......',
                     'LD_CLF','->PARA','-> EDI','-> DOS','IMGEXT');

 KeysPlot:  KeyTxt =('Plot',
                     '  COOR',' K_PLG','CNFNET','NMB_CL','......',
                     ' START','      ',' IMAGE',' CLEAR','MAIN<-');

 KeysParam: KeyTxt =('Param',
                     '->PATH','->COLS','WCOLOR','WRTIMG','......',
                     'LD_CNF','......','......','      ','MAIN<-');

 KeysPfade: KeyTxt =('Paths',
                     '      ','ED_PFD','LD_PFD','SV_PFD','      ',
                     '......','      ','      ','      ','PARA<-');

 KeysFarbe: KeyTxt =('Colors',
                     '      ','ED_FRB','LD_FRB','SV_FRB','      ',
                     '      ','      ','      ','      ','PARA<-');




procedure PlotKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPlot,TastePlot);
  case TastePlot of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  SetColor(KEckColor);
                  l_art:=LMuster[KEckLineStyle];
                  PlotKEck;
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   3: begin
      if KlAnz<>3 then begin
                       ErrorMessage('Number of Classes Must be Three');
                       WaitForReturn;
                       ClrDskTpG(ActPage);
                       end
      else begin
           ActPage:=1; SetActivePage(ActPage);
                       SetVisualPage(ActPage);
                       SetColor(NetzColor);
                       l_art:=LMuster[NetzLineStyle];
                       PlotDreiKlassenNetz;
           WaitforReturn;
           ActPage:=0; SetActivePage(ActPage);
                       SetVisualPage(ActPage);
           end;
      end;
   4: begin
      Message('Determine Decision Space');
      OvWrt:=True;
      repeat
       GetWertI('Number of Classes: ',Integer(KlAnz));
      until (KlAnz>=1) and (KlAnz<=AnzElemMod);
      ProjMatrixInit;
      ClrDskTpG(ActPage);
      end;
   5: begin
      if PltSmpl=1 then PltSmpl:=2 else PltSmpl:=1;
      KeysPlot[5]:=PltSmplStr(PltSmpl);
      end;
   6: begin
      if Leer(RdDatei) then
       begin
       ErrorMessage('No Inputfile available');
       WaitForReturn;
       ClrDskTpG(ActPage);
       end
      else
       begin
       Assign(f,RdDatei); ReSet(f);
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   repeat
                    if SrcDvekt then
                     begin
                     ReadLn(f,s); GetPar(s);
                     sc:=ParStr(1); SmplClass:=sc[1];
                     SmplNr:=ValI(ParStr(2));
                     for k:=3 to ParCount do DVkt[k-2]:=ValR(ParStr(k));
                     end
                    else
                     begin
                     ReadLn(f,SmplClass,SmplNr,v[1],v[2]);
                     case ModeKlf of
                      stm: DVekt(KlfDat,v,SmplClass,ErkErg);
                      nnt: DVektNnt(Netz,v,SmplClass,ErkErg);
                      zep: DVektZep(Psl,ClsLst,Koeff,v,SmplClass,ErkErg);
                     end;
                     DVkt:=ErkErg.dvkt;
                     end;
                    if ProjInDcsp then ProjInDecSpace(DVkt);
                    if (ClSlct=[]) or (SmplClass in ClSlct) then
                     begin
                     SmplColor:=ColorLst[Ord(SmplClass)];
                     Proj(Dvkt,v);
                     case PltSmpl of
                      1: PlotV(v,SmplColor);
                      2: begin
                         SetColor(SmplColor);
                         PlotSymbV(v,SmplClass);
                         end;
                     end;
                     end;
                   until Eof(f) or (KeyPressed and (Readkey=#27));
                   Close(f);
       WaitForReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      ClrDskTpG(ActPage);
      end;
   8: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
    9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TastePlot=10;
 end;


procedure PfadeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPfade,TastePfade);
  case TastePfade of
   2: begin
      EditMskG(PfadeMaske,OK,rm);
      PfadeInitDecSp(PfadeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Paths and Defaults');
      GtRdFileNameG(100,100,PfadePfad,PfadeRdDatei);
      if not Leer(PfadeRdDatei) then begin
                                     LoadMsk(PfadeRdDatei,PfadeMaske,OK);
                                     PfadeInitDecSp(PfadeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Paths and Defaults');
      GtWrFileNameG(100,100,PfadePfad,PfadeSvDatei);
      if not Leer(PfadeSvDatei) then SaveMsk(PfadeSvDatei,PfadeMaske,OK);
      ClrDskTpG(ActPage);
      end;
   6: begin
      {if RdbTyp=clcprb then RdbTyp:=apoprb else RdbTyp:=Succ(RdbTyp);
      case RdbTyp of
       apoprb: KeysPfade[6]:='APOPRB';
       clcprb: KeysPfade[6]:='CLCPRB';
      end;}
      end;
  end;
 until TastePfade=10;
 end;


procedure FarbeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysFarbe,TasteFarbe);
  case TasteFarbe of
   2: begin
      EditMskG(FarbeMaske,OK,rm);
      ColorInitDecSp(FarbeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Representation Parameters');
      GtRdFileNameG(100,100,FarbePfad,FarbeRdDatei);
      if not Leer(FarbeRdDatei) then begin
                                     LoadMsk(FarbeRdDatei,FarbeMaske,OK);
                                     ColorInitDecSp(FarbeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Representation Parameters');
      GtWrFileNameG(100,100,FarbePfad,FarbeSvDatei);
      if not Leer(FarbeSvDatei) then SaveMsk(FarbeSvDatei,FarbeMaske,OK);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteFarbe=10;
 end;


procedure ParamKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysParam,TasteParam);
  case TasteParam of
   1: PfadeKeys;
   2: FarbeKeys;
   3: begin
      repeat
       s:=ColorToStr(BeschrColor);
       OvWrt:=True;
       GetStr('Color for Writing Text in Image: ',12,s);
       BeschrColor:=ColorFromStr(s);
      until BeschrColor<=15;
      ClrDskTpG(ActPage);
      end;
   4: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  TextColor(BeschrColor);
                  TextBackGround(DsktpColor[ActPage]);
                  Beschrifte;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   5: begin
      if not (KlfDatFertig and GlbwDatFertig) then
       begin
       ErrorMessage('No Classifier and Confidence Mapping available');
       WaitForReturn;
       ClrDsktpG(ActPage);
       end
      else
      if CheckCompatKlfCnf then CnfMap:=not CnfMap else CnfMap:=False;
      if CnfMap then KeysParam[5]:='   CNF'
                else KeysParam[5]:='NO_CNF';
      end;
   6: begin
      Message('Select Inputfile Confidence Mapping');
      GtRdFileNameG(100,100,CnfPfad,CnfRdDatei);
      if not Leer(CnfRdDatei) then begin
                                   LoadGlbw(CnfRdDatei,OK);
                                   GlbwDatFertig:=True;
                                   CnfMap:=False; KeysParam[5]:='NO_CNF';
                                   end;
      ClrDskTpG(ActPage);
      end;
   7: begin
      if ModeKlf=nnt then ModeKlf:=stm else ModeKlf:=Succ(ModeKlf);
      case ModeKlf of
       stm: KeysParam[7]:='MD_KLF';
       nnt: KeysParam[7]:='MD_NNT';
       zep: KeysParam[7]:='MD_ZEP';
      end;
      {RadBas:=False; KeysParam[8]:='NO_RDB';}
      end;
   8: begin
      {If (ModeKlf=zep) and not RadBas then RadBas:=True else RadBas:=False;
      if RadBas then begin
                     KeysParam[8]:='   RDB';
                     Message('Eingabe Aufweitungsfaktor RdbFak');
                     GetWertR('RdbFak: ',RdbFak);
                     ClrDskTpG(ActPage);
                     end
                else KeysParam[8]:='NO_RDB';}
      end;
   9: begin
      {Message('Auswahl Zepas-RadBas-Eingabedatei');
      GtRdFileNameG(100,100,ZRdbPfad,ZRdbRdDatei);
      if not Leer(ZRdbRdDatei) then
       begin
       if ZRdbDatFertig then dispose(RdbDat,done);
       RdbDat:=New(RdbDat_P,InitLoad(ZRdbRdDatei,RdbFak));
       ZRdbDatFertig:=True;
       end;
      ClrDskTpG(ActPage);}
      end;
 end;
 until TasteParam=10;
 end;


procedure MainKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysMain,TasteMain);
  case TasteMain of
   1: PlotKeys;
   2: begin
      ProjInDcsp:=not ProjInDcsp;
      if ProjInDcsp then KeysMain[2]:='   PRJ'
                    else KeysMain[2]:='NO_PRJ';
      end;
   3: begin
      if SrcDVekt then begin
                       Message('Select Inputfile Discriminantvectors');
                       GtRdFileNameG(100,100,DvektPfad,RdDatei);
                       end
                  else begin
                       Message('Select Inputfile Measurementvectors');
                       GtRdFileNameG(100,100,StchpPfad,RdDatei);
                       end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Selection of Classes');
      s:=SetToStr(ClSlct);
      GetStr('Select : ',50,s);
      SetFromStr(s,ClSlct);
      ColorListInit(ClSlct,ColorLst);
      ClrDskTpG(ActPage);
      end;
   5: begin
      if not (KlfDatFertig   or
              ZklfDatFertig) then
                               begin
                               ErrorMessage('No Classifier available');
                               WaitForReturn;
                               ClrDskTpG(ActPage);
                               end
      else begin
           SrcDVekt:=not SrcDVekt;
           if SrcDVekt then KeysMain[5]:='D_VECT'
                       else KeysMain[5]:='V_VECT';
           end;
      end;
   6: begin
      case ModeKlf of
       stm: begin
            Message('Select Inputfile Classifier');
            GtRdFileNameG(100,100,KlfPfad,KlfRdDatei);
            if not Leer(KlfRdDatei) then
             begin
             LoadKlf(KlfRdDatei,KlfDat,OK);
             ClsLstFromKlfDat(KlfDat,ClsLst,Klanz);
             KlfDatFertig:=OK;
             CnfMap:=False; KeysParam[5]:='NO_CNF';
             ClSlctFromClsLst(ClsLst,Klanz,ClSlct);
             ColorListInit(ClSlct,ColorLst);
             ProjMatrixInit;
             end;
            end;
       nnt: begin
            Message('Select Inputfile MLP Network');
            GtRdFileNameG(100,100,NntPfad,NntRdDatei);
            if not Leer(NntRdDatei) then
             begin
             LoadNnt(NntRdDatei,Netz,OK);
             InitNntVar(Netz);
             ClsLstFromNnt(Netz,ClsLst,Klanz);
             KlfDatFertig:=OK;
             ClSlctFromClsLst(ClsLst,Klanz,ClSlct);
             ColorListInit(ClSlct,ColorLst);
             ProjMatrixInit;
             end;
            end;
      { zep: begin
            Message('Auswahl Zepas-Klassifikator-Eingabedatei');
            GtRdFileNameG(100,100,ZKlfPfad,ZKlfRdDatei);
            if not Leer(ZKlfRdDatei) then
             begin
             if Koeff<>Nil then dispose(Koeff,done);
             Klf:=new(ClfDat_P,InitLoad(ZKlfRdDatei));
               Psl:=   Klf^.PslDat;
               Klanz:= Klf^.Matrix^.col;
               for k:=1 to Klanz do ClsLst[k]:=Klf^.Classes[k];
               Koeff:=new(PMatrix,InitCopy(Klf^.Matrix));
               Koeff^.Transpose;
             dispose(Klf,done);

             if Radbas then
                begin
                if not ZRdbDatFertig then
                  begin
                  ErrorMessage('RdbDat fehlt');
                  WaitForReturn;
                  end
                 else
                  begin
                  if Psl.LengthMv<>RdbDat^.LengthPv then
                   begin
                   ErrorMessage('Klassifikator pat nicht zu RdbDat');
                   ZKlfDatFertig:=False;
                   WaitForReturn;
                   end
                   else ZKlfDatFertig:=True;
                  end;
                end
              else
                begin
                if Psl.LengthMv<>2 then
                   begin
                   ErrorMessage('Klassifikator ist nicht fr dim[v]=2');
                   ZKlfDatFertig:=False;
                   WaitForReturn;
                   end
                  else ZKlfDatFertig:=True;
                end;

             CnfMap:=False; KeysParam[5]:='NO_CNF';
             ClSlctFromClsLst(ClsLst,Klanz,ClSlct);
             ColorListInit(ClSlct,ColorLst);
             ProjMatrixInit;
             end;
            end;}
      end;
      ClrDskTpG(ActPage);
      end;
   7: ParamKeys;
   8: begin
      RestoreCrtMode;
      SwapVectors;
      Exec(Editorpfad,'');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      ClrDskTpG(ActPage);
      end;
   9: begin
      w:=DskTpColor[ActPage];
      DskTpColor[ActPage]:=Black;
      ClrDskTpG(ActPage);
      RestoreCrtMode;
      SwapVectors;
      Exec('C:\COMMAND.COM','');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      DskTpColor[ActPage]:=w;
      ClrDskTpG(ActPage);
      end;
   end;
  until TasteMain=10;
 end;



begin
(*Directvideo:=False; *)
DetectGraph(GrDr,GrMd); GrMd:=1;
DtctGrphPar(ChrW,ChrH,AnzPxH,AnzPxV);
BGIPfad:=GetEnv('BGIPFAD');
InitGraph(GrDr,GrMd,BGIPfad);
MouseReset;

PfadePfad:=  '*.MSK';
PfadeRdDflt:='PFADDCSP.MSK';
KoorRdDflt:= 'KOORDCSP.MSK';
FarbeRdDflt:='FARBDCSP.MSK';

ZchFld:=scrn; ZchFldInit;

LoadMsk(PfadeRdDflt,PfadeMaske,OK);
 if not OK then WriteXYG(100,100,PfadeRdDflt+' not found')
           else PfadeInitDecSp(PfadeMaske);
LoadMsk(KoorRdDatei,KoorMaske,OK);
 if not OK then WriteXYG(100,110,KoorRdDatei+' not found')
           else KoorInit(KoorMaske.erg,Koor);
LoadMsk(FarbeRdDatei,FarbeMaske,OK);
 if not OK then WriteXYG(100,130,FarbeRdDatei+' not found')
           else ColorInitDecSp(FarbeMaske);


KlAnz:=3; ProjMatrixInit;
PltSmpl:=1; KeysPlot[5]:=PltSmplStr(PltSmpl);
RdDatei:='';
OutlSchw:=10;
RadqSchw:=4.0;
KlfDatFertig:=False;
ZKlfDatFertig:=False;
ZRdbDatFertig:=False;
RdbFak:=1.0;

SrcDVekt:=True;    KeysMain[5]:= 'D_VECT';
ModeKlf:=stm;      KeysParam[7]:='MD_CLF';
RadBas:=False;     KeysParam[8]:='      ';
CnfMap:=False;     KeysParam[5]:='NO_CNF';
ProjInDcsp:=False; KeysMain[2]:= 'NO_PRJ';
RdbTyp:=apoprb;    KeysPfade[6]:='      ';

for k:=1 to AnzElemMod do DVkt[k]:=0;
ClSlct:=           []; ColorListInit(ClSlct,ColorLst);
BeschrColor:=      White;


ActPage:=1; {Grafikseite}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);
ActPage:=0; {Textseite im Grafikmode}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);

Titel('DCSP');

while WaitForReturnOrEscape do begin
                               ActPage:=0; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                                           ClrDsktpG(ActPage);
                                           MainKeys;
                               ActPage:=1; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                               end;

if ZKlfDatFertig then dispose(Koeff,done);
if ZRdbDatFertig then dispose(RdbDat,done);
Closegraph;
end.
