program NNTe;

{$M 16000,0,30000}


Uses
 graph,dos,crt,
 js_sub,js_acc,js_key,js_tio,js_fio,js_koor,js_stm,js_mtr,js_gra,
 pc_mouse,js_nnt;

Var
 ch:          Char;
 w:           Word;
 i,j:         Integer;
 wert:        Real;
 s:           String;
 EdiDatei:    PathStr;

 StMod:  StMod_T;
 EmpMod: StMod_T;

 PfadeMaske: MskPar_T;
 KoorMaske:  MskPar_T;
 FarbeMaske: MskPar_T;

 TasteMain      : FktTst;
   TastePlot    : FktTst;
   TasteKoor    : FktTst;
   TasteStMod   : FktTst;
   TasteStchp   : FktTst;
   TasteRek     : FktTst;
     TasteNntMk : FktTst;
      TasteNntPl: FktTst;
     TasteKlfMk : FktTst;
   TasteKlf     : FktTst;
     TasteKlfPl : FktTst;
     TasteErk   : FktTst;
     TasteStaPl : FktTst;
   TasteParam   : FktTst;
     TastePfade : FktTst;
     TasteFarbe : FktTst;


Const
 KeysMain:  KeyTxt =('Main',
                     '->PLOT','->COOR','->STMD','->SMPL','-> REC',
                     '-> CLF','->PARA','-> EDI','-> DOS','IMGEXT');

 KeysPlot:  KeyTxt =('Plot',
                     '  COOR','  AXES','ELLIPS','BORDER','RLV_BD',
                     '......','......',' START',' CLEAR','MAIN<-');

 KeysKoor:  KeyTxt =('Coor',
                     '  PLOT','  EDIT','LD_COO','SV_COO','      ',
                     '      ','      ',' IMAGE',' CLEAR','MAIN<-');

 KeysStMod: KeyTxt =('StMod',
                     'ED_APR','ED_COL','LD_MOD','SV_MOD','      ',
                     '      ','-> EDI','R_SEED','R_INIT','MAIN<-');

 KeysStchp: KeyTxt =('Sample',
                     'POIPLT','NUMDER','RDSMPL','WRSMPL','NOCYKL',
                     ' MODEL','      ','NO_CNT','SH_CNT','MAIN<-');

 KeysRek:   KeyTxt =('Recurs',
                     '-> NNT','-> CLF','      ','STPPRO','SV_PRO',
                     '......','......','      ','      ','MAIN<-');

 KeysNntMk: KeyTxt =('NntMk',
                     'CREATE','LD_NNT','SV_NNT','->PLOT','      ',
                     'ALPMIN','ALPCON',' ALPHA','INIWGH','REC <-');

 KeysNntPl: KeyTxt =('NntPlt',
                     '  COOR','REGION','BORDER','FIRSTL','......',
                     'LCOLOR','LSTYLE',' IMAGE',' CLEAR','NNT <-');

 KeysKlfMk: KeyTxt =('ClfMk',
                     'CREATE','      ','      ','      ','      ',
                     '-> EDI','      ',' ALPHA','      ','REC <-');

 KeysKlf:   KeyTxt =('Clf',
                     '      ','      ','LD_CLF','SV_CLF','->PLOT',
                     '-> REC','LD_STA','SV_STA','->STPL','MAIN<-');

 KeysKlfPl: KeyTxt =('ClfPlt',
                     '  COOR','REGION',' D_FCT','BORDER','RLV_BD',
                     '      ','      ',' IMAGE',' CLEAR','CLF <-');

 KeysErk:   KeyTxt =('Recogn',
                     'OUTLTH','CONFTH','RADQTH','WRDVKT','      ',
                     'NODSPL','NOSTEP','NOSTAT','SELECT','CLF <-');

 KeysStaPl: KeyTxt =('StaPlt',
                     '  COOR','LD_COO','   EPS','   ALT','EPSALT',
                     'LCOLOR','LSTYLE',' IMAGE',' CLEAR','CLF <-');

 KeysParam: KeyTxt =('Param',
                     '->PATH','->COLS','WCOLOR','WRTIMG','      ',
                     'SELECT','HYSTEP','      ',' BLOCK','MAIN<-');

 KeysPfade: KeyTxt =('Path',
                     '      ','  EDIT','LD_PFD','SV_PFD','      ',
                     '      ','      ','      ','      ','PARA<-');

 KeysFarbe: KeyTxt =('Colors',
                     '      ','  EDIT','LD_FRB','SV_FRB','      ',
                     '      ','      ','      ','      ','PARA<-');




procedure PfadeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPfade,TastePfade);
  case TastePfade of
   2: begin
      EditMskG(PfadeMaske,OK,rm);
      PfadeInitStm(PfadeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Paths and Defaults');
      GtRdFileNameG(100,100,PfadePfad,PfadeRdDatei);
      if not Leer(PfadeRdDatei) then begin
                                     LoadMsk(PfadeRdDatei,PfadeMaske,OK);
                                     PfadeInitStm(PfadeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Paths and Defaults');
      GtWrFileNameG(100,100,PfadePfad,PfadeSvDatei);
      if not Leer(PfadeSvDatei) then SaveMsk(PfadeSvDatei,PfadeMaske,OK);
      ClrDskTpG(ActPage);
      end;
  end;
 until TastePfade=10;
 end;


procedure FarbeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysFarbe,TasteFarbe);
  case TasteFarbe of
   2: begin
      EditMskG(FarbeMaske,OK,rm);
      ColorInitStm(FarbeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Presentation Parameters');
      GtRdFileNameG(100,100,FarbePfad,FarbeRdDatei);
      if not Leer(FarbeRdDatei) then begin
                                     LoadMsk(FarbeRdDatei,FarbeMaske,OK);
                                     ColorInitStm(FarbeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Presentation Parameters');
      GtWrFileNameG(100,100,FarbePfad,FarbeSvDatei);
      if not Leer(FarbeSvDatei) then SaveMsk(FarbeSvDatei,FarbeMaske,OK);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteFarbe=10;
 end;


procedure ParamKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysParam,TasteParam);
  case TasteParam of
   1: PfadeKeys;
   2: FarbeKeys;
   3: begin
      repeat
       s:=ColorToStr(BeschrColor);
       OvWrt:=True;
       GetStr('Color for Writing Text in Image: ',12,s);
       BeschrColor:=ColorFromStr(s);
      until BeschrColor<=15;
      ClrDskTpG(ActPage);
      end;
   4: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  TextColor(BeschrColor);
                  TextBackGround(DsktpColor[ActPage]);
                  Beschrifte;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   6: begin
      Message('Selection of Classes');
      s:=SetToStr(ClSlct);
      GetStr('Select : ',50,s);
      SetFromStr(s,ClSlct);
      ClrDskTpG(ActPage);
      end;
   7: begin
      Message('Stepwidth for Hyperbola Plot');
      GetWertR('HyperbelStep : ',HyperbelStep);
      ClrDskTpG(ActPage);
      end;
   8: begin
      {Message('Stichprobeneingabe aus ASCII-Datei mit 4*10 Merkmalen');
      s:=StrI(Index1,2)+' '+StrI(Index2,2);
      GetStr('Index1, Index2 : ',5,s);
      Getpar(s); Index1:=ValI(ParStr(1));
                 Index2:=ValI(ParStr(2));
      Stchp40:=(Index1>0) and (Index2>0);
      ClrDskTpG(ActPage);}
      end;
   9: begin
      Message('Blocksize for Region Plot, >3');
      repeat
       OvWrt:=True;
       GetWertI('Block : ',Block);
      until Block>3;
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteParam=10;
 end;


procedure StaPlotKeys;
 begin
 SetColor(StatColor);
 l_art:=Lmuster[StatLineStyle];
 repeat
  GetFktTstG(550,8,KeysStaPl,TasteStaPl);
  case TasteStaPl of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      Message('Select Inputfile Coordinate System');
      GtRdFileNameG(100,100,KoorPfad,KoorRdDatei);
      if not Leer(KoorRdDatei) then begin
                                    LoadMsk(KoorRdDatei,KoorMaske,OK);
                                    KoorInit(KoorMaske.erg,Koor);
                                    end;
      ClrDskTpG(ActPage);
      end;
   3: begin
      if not StatistikFertig then
       begin
       ErrorMessage('No Statistic available');
       WaitForReturn;
       ClrDskTpG(ActPage);
       end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   SetColor(StatColor);
                   l_art:=Lmuster[StatLineStyle];
                   PlotEps;
       WaitForReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   4: begin
      if not StatistikFertig then
       begin
       ErrorMessage('No Statistic available');
       WaitForReturn;
       ClrDskTpG(ActPage);
       end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   SetColor(StatColor);
                   l_art:=Lmuster[StatLineStyle];
                   PlotAlt;
       WaitForReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   5: begin
      if not StatistikFertig then
       begin
       ErrorMessage('No Statistic available');
       WaitForReturn;
       ClrDskTpG(ActPage);
       end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   SetColor(StatColor);
                   l_art:=Lmuster[StatLineStyle];
                   PlotEpsAlt;
       WaitForReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   6: begin
      repeat
       s:=ColorToStr(StatColor);
       OvWrt:=True;
       GetStr('Line Color: ',12,s);
       StatColor:=ColorFromStr(s);
      until StatColor<=15;
      ClrDskTpG(ActPage);
      end;
   7: begin
      Ovwrt:=True;
      repeat
       GetWertI('Line Style: ',StatLineStyle);
      until (StatLinestyle>=0) and (StatLinestyle<=9);
      ClrDskTpG(ActPage);
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteStaPl=10;
 end;


procedure ErkKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysErk,TasteErk);
  case TasteErk of
   1: begin
      Message('Outlier-Threshold as Sigma-Multiple');
      GetWertR('OutlThrsh : ',OutlSchw);
      ClrDskTpG(ActPage);
      end;
   2: begin
      Message('Confidence-Threshold, active for QMX, PKX');
      GetWertR('ConfThrsh : ',GlbwSchw);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Square-of-Rad-Threshold, active for QMK');
      GetWertR('RadqThrsh : ',RadqSchw);
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Discriminant Vectors');
      GtWrFileNameG(100,100,DvektPfad,DVektSvDatei);
      WrDVkt:=not Leer(DVektSvDatei);
      ClrDskTpG(ActPage);
      end;
   6: begin
      DsplErkErg:= not DsplErkErg;
      if DsplErkErg then KeysErk[6]:='  DSPL'
                    else KeysErk[6]:='NODSPL';
      end;
   7: begin
      SnglStp:= not SnglStp;
      if SnglStp then KeysErk[7]:='  STEP'
                 else KeysErk[7]:='NOSTEP';
      end;
   8: begin
      AkkStat:= not AkkStat;
      if AkkStat then KeysErk[8]:='  STAT'
                 else KeysErk[8]:='NOSTAT';
      end;
   9: begin
      GetSelectCode(SlctCode);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteErk=10;
 end;


procedure KlfPlotKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysKlfPl,TasteKlfPl);
  case TasteKlfPl of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      if not (ClsfMode in [1,2]) then
                               begin
                               ErrorMessage('Activate Mode MD_CLF or MD_NNT');
                               WaitForReturn;
                               ClrDsktpG(ActPage);
                               end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   case ClsfMode of
                    1: PlotClassRegions(KlfDat);
                    2: PlotClassRegionsNnt(Netz);
                   end;
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   3: begin
      if not KlfDatFertig then
       begin
       ErrorMessage('No Classifier available');
       WaitForReturn;
       ClrDsktpG(ActPage);
       end
      else
       begin
       if not ((KlfDat.typ='NVK') or (KlfDat.typ='QMK') or (KlfDat.typ='QMX')) then
        begin
        ErrorMessage('No NVK, QMK or QMX Classifier');
        WaitForReturn;
        ClrDsktpG(ActPage);
        end
       else
        begin
        ActPage:=1; SetActivePage(ActPage);
                    SetVisualPage(ActPage);
                    for i:=1 to KlfDat.anz do
                     if (ClSlct=[]) or (KlfDat.dat[i].class in ClSlct) then
                      begin
                      if DfunktColor=255 then SetColor(Classcolor[(i-1) mod 12])
                                         else SetColor(DFunktColor);
                      with KlfDat do
                       for j:=0 to 4 do
                        begin
                        l_art:=Lmuster[7+(j mod 2)];
                        PlotQFkt(dat[i],0.25*j);
                        end;
                     end;
        WaitforReturn;
        ActPage:=0; SetActivePage(ActPage);
                    SetVisualPage(ActPage);
        end;
       end;
      end;
   4: begin
      if not KlfDatFertig then
       begin
       ErrorMessage('No Classifier available');
       WaitForReturn;
       ClrDsktpG(ActPage);
       end
      else
       begin
       if not ((KlfDat.typ='NVK') or (KlfDat.typ='QMK') or (KlfDat.typ='QMX')) then
        begin
        ErrorMessage('No NVK, QMK oder QMX Classifier');
        WaitForReturn;
        ClrDsktpG(ActPage);
        end
       else
        begin
        ActPage:=1; SetActivePage(ActPage);
                    SetVisualPage(ActPage);
                    l_art:=LMuster[QMKGrenzenLineStyle];
                    SetColor(QMKGrenzencolor);
                    for i:=1 to KlfDat.anz do
                     if (ClSlct=[]) or (KlfDat.dat[i].class in ClSlct) then
                      for j:=i+1 to KlfDat.anz do
                       if ((ClSlct=[]) or (KlfDat.dat[j].class in ClSlct)) then
                        PlotQMKGrenze(i,j);
        WaitforReturn;
        ActPage:=0; SetActivePage(ActPage);
                    SetVisualPage(ActPage);
        end;
       end;
      end;
   5: begin
      RelevanteGrenzen:= not RelevanteGrenzen;
      if RelevanteGrenzen then KeysKlfPl[5]:='RLV_BD'
                          else KeysKlfPl[5]:='ALL_BD';
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteKlfPl=10;
 end;


procedure NntPlotKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysNntPl,TasteNntPl);
  case TasteNntPl of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      if not (ClsfMode in [1,2]) then
                               begin
                               ErrorMessage('Activate Mode MD_NNT or MD_CLF');
                               WaitForReturn;
                               ClrDsktpG(ActPage);
                               end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   case ClsfMode of
                    1: PlotClassRegions(KlfDat);
                    2: PlotClassRegionsNnt(Netz);
                   end;
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   3: begin
      if not (ClsfMode in [1,2]) then
                               begin
                               ErrorMessage('Activate Mode MD_CLF or MD_NNT');
                               WaitForReturn;
                               ClrDsktpG(ActPage);
                               end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   case ClsfMode of
                    1: PlotClassBorders(KlfDat);
                    2: PlotClassBordersNnt(Netz);
                   end;
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   4: begin
      if not NntDatFertig then begin
                               ErrorMessage('No MLP Network available');
                               WaitForReturn;
                               ClrDskTpG(ActPage);
                               end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   SetColor(NntFirstLColor);
                   L_Art:=LMuster[NntFirstLLineStyle];
                   if FirstLayerNode=0 then
                       for i:=1 to Netz.NntModul[1].AnzOut do
                         PlotZeroLineFirstLayerNnt(Netz,i)
                      else PlotZeroLineFirstLayerNnt(Netz,FirstLayerNode);
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);

       end;
      end;
   5: begin
      if NntDatFertig then
       begin
       If FirstLayerNode<Netz.NntModul[1].AnzOut then
            Inc(FirstLayerNode) else FirstLayerNode:=0;
       if FirstLayerNode=0 then KeysNntPl[5]:='   All'
                           else KeysNntPl[5]:='Node'+StrI(FirstLayerNode,2);
       end;
      end;
   6: begin
      repeat
       s:=ColorToStr(NntFirstLColor);
       OvWrt:=True;
       GetStr('Line Color: ',12,s);
       NntFirstLColor:=ColorFromStr(s);
      until NntFirstLColor<=15;
      ClrDskTpG(ActPage);
      end;
   7: begin
      Ovwrt:=True;
      repeat
       GetWertI('Line Style: ',NntFirstLLineStyle);
      until (NntFirstLLinestyle>=0) and (NntFirstLLinestyle<=9);
      ClrDskTpG(ActPage);
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteNntPl=10;
 end;


procedure NntMkKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysNntMk,TasteNntMk);
  case TasteNntMk of
   1: begin
      Message('Determine Network Architecture');
      with Netz do
       begin
       ClsLstFromClSlct(ClSlct,Klanz,ClsLst);
       NntClasses:=ClsLst;
       OvWrt:=True;
       repeat
        GetWertI('Number of Processing Layers (1..3) = ',AnzModuls);
       until (AnzModuls>=1) and (AnzModuls<=3);
       for i:=1 to AnzModuls-1 do
        begin
        j:=2;
        repeat
         GetWertI('After Processing Layer '+StrI(i,1)+': Number of Hidden Nodes = ',j);
        until (j>=2) and (j<=MaxAnzNodes);
        NntModul[i].AnzOut:= j;
        NntModul[i+1].AnzIn:=j;
        end;
        NntModul[AnzModuls].AnzOut:=Klanz;
       end;
      InitNntVar(Netz);
      InitNntGew(Netz);
      NntDatFertig:=True;
      KlfSrc:='Init-Netz';
      ClrDskTpG(ActPage);
      end;
   2: begin
      Message('Select Inputfile NNT-Classifier');
      GtRdFileNameG(100,100,NntPfad,NntRdDatei);
      if not Leer(NntRdDatei) then
        begin
        LoadNnt(NntRdDatei,Netz,OK);
        InitNntVar(Netz);
        KlfSrc:=NntRdDatei;
        ClsLstFromNnt(Netz,ClsLst,Klanz);
        ClSlctFromClsLst(ClsLst,Klanz,ClSlct);
        NntDatFertig:=OK;
        end;
      ClrDskTpG(ActPage);
      end;
   3: begin
      if not NntDatFertig then ErrorMessage('No MLP Network available')
      else
       begin
       Message('Select Outputfile NNT-Classifier');
       GtWrFileNameG(100,100,NntPfad,NntSvDatei);
       if not Leer(NntSvDatei) then
         SaveNnt(NntSvDatei,Netz,OK);
       ClrDskTpG(ActPage);
       end;
      end;
   4: NntPlotKeys;
   6: begin
      Message('Minimum Learning Factor Alpha');
      GetWertR('AlphaMin : ',AlphaMin);
      ClrDskTpG(ActPage);
      end;
   7: begin
      AlphaCon:=not AlphaCon;
      if not AlphaCon then
       begin
       Message('Learning Faktor Alpha will be Decreased in Steps');
       GetWertLongI('After every AlphaZykl Learning Steps : ',AlphaZykl);
       GetWertR('Alpha is Reduced by AlphaFak : ',AlphaFak);
       ClrDskTpG(ActPage);
       end;
      if AlphaCon then KeysNntMk[7]:='ALPCON'
                  else KeysNntMk[7]:='ALPVAR';
      end;
   8: begin
      Message('Learning Factor Alpha');
      GetWertR('AlphaNnt : ',AlphaNnt);
      ClrDskTpG(ActPage);
      end;
   9: begin
      Message('Initialisation Weight');
      GetWertR('InitGew : ',InitGew);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteNntMk=10;
 end;


procedure KlfMkKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysKlfMk,TasteKlfMk);
  case TasteKlfMk of
   1: begin
      InitKlf(KlfDat);
      KlfDatFertig:=True;
      KlfSrc:='Init-Klf';
      end;
   6: begin
      GtWrFileNameG(100,100,RzpPfad,EdiDatei);
      RestoreCrtMode;
      SwapVectors;
      Exec(EditorPfad,EdiDatei);
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      ClrDskTpG(ActPage);
      end;
   7: begin
      end;
   8: begin
      Message('Learning Faktor Alpha');
      GetWertR('AlphaKlf : ',AlphaKlf);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteKlfMk=10;
 end;



procedure KlfKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysKlf,TasteKlf);
  case TasteKlf of
   1: begin end;
   3: begin
      Message('Select Inputfile Classifier');
      GtRdFileNameG(100,100,KlfPfad,KlfRdDatei);
      if not Leer(KlfRdDatei) then
        begin
        LoadKlf(KlfRdDatei,KlfDat,OK);
        ClsLstFromKlfDat(KlfDat,ClsLst,KlAnz);
        ClSlctFromClsLst(ClsLst,Klanz,ClSlct);
        KlfSrc:=KlfRdDatei;
        KlfDatFertig:=OK;
        end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outpufile Classifier');
      GtWrFileNameG(100,100,KlfPfad,KlfSvDatei);
      if not Leer(KlfSvDatei) then
        SaveKlf(KlfSvDatei,KlfDat,OK);
      ClrDskTpG(ActPage);
      end;
   5: KlfPlotKeys;
   6: ErkKeys;
   7: begin
      Message('Select Inputfile Statistic');
      GtRdFileNameG(100,100,StatPfad,StatRdDatei);
      if not Leer(StatRdDatei) then LoadStatistik(StatRdDatei,OK);
       if OK then StatistikFertig:=True;
      ClrDsktpG(ActPage);
      end;
   8: begin
      if not StatistikFertig then
       begin
       ErrorMessage('No Statistic available');
       WaitForReturn;
       end
      else
       begin
       Message('Select Inputfile Statistic');
       GtWrFileNameG(100,100,StatPfad,StatSvDatei);
       if not Leer(StatSvDatei) then SaveStatistik(StatSvDatei,OK);
       end;
       ClrDsktpG(ActPage);
      end;
   9: StaPlotKeys;
   end;
 until TasteKlf=10;
 end;


procedure RekKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysRek,TasteRek);
  case TasteRek of
   1: NntMkKeys;
   2: KlfMkKeys;
   4: begin
      Message('Determine Stepwidth for Protocol');
      GetWertLongI('StepPro : ',StepPro);
      ClrDskTpG(ActPage);
      end;
   5: begin
      Message('Select Outputfile Protocol');
      GtWrFileNameG(100,100,ProPfad,ProSvDatei);
      ClrDskTpG(ActPage);
      end;
   6: begin
      Lernen:= not Lernen;
      if Lernen then KeysRek[6]:='  LEAR'
                else KeysRek[6]:='NOLEAR';
      end;
   7: begin
      ShPro:= not ShPro;
      if ShPro then KeysRek[7]:='SH_PRO'
               else KeysRek[7]:='SH_NOT';
      end;
  end;
 until TasteRek=10;
 end;


procedure StchpKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysStchp,TasteStchp);
  case TasteStchp of
   1: begin
      PltSmpl:=(PltSmpl+1) mod 3;
      KeysStchp[1]:=PltSmplStr(PltSmpl);
      end;
   2: begin
      Message('Total Number of Samples to be Processed');
      GetWertLongI('Anzahl : ',StAnz);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Samples');
      GtRdFileNameG(100,100,StchpPfad,StchpRdDatei);
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Samples');
      GtWrFileNameG(100,100,StchpPfad,StchpSvDatei);
      WrSmpl:=not Leer(StchpSvDatei);
      ClrDskTpG(ActPage);
      end;
   5: begin
      SmplZykl:= not SmplZykl;
      if SmplZykl then KeysStchp[5]:='  CYKL'
                  else KeysStchp[5]:='NOCYKL';
      end;
   6: begin
      SmplSrcMod:= not SmplSrcMod;
      if SmplSrcMod then KeysStchp[6]:=' MODEL'
                    else KeysStchp[6]:='SMPSET';
      end;
   8: begin
      SmplCount:= not SmplCount;
      if SmplCount then KeysStchp[8]:=' COUNT'
                   else KeysStchp[8]:='NO_CNT';
      end;
   9: begin
      ShwClCnt;
      WaitForReturn;
      ClrDsktpG(ActPage);
      end;
  end;
 until TasteStchp=10;
 end;


procedure StModKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysStMod,TasteStMod);
  case TasteStMod of
   1: begin
      EditAPrioG(30,30,StMod);
      StModInit(StMod);
      ClrDskTpG(ActPage);
      end;
   2: begin
      EditClassColorG(30,30,ModPar);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Statistical Model');
      GtRdFileNameG(100,100,StModPfad,StModRdDatei);
      if not Leer(StModRdDatei) then begin
                                     LoadStMod(StModRdDatei,StMod,OK);
                                     StModInit(StMod);
                                     ClsLstFromStMod(StMod,ClsLst,KlAnz);
                                     ClSlctFromClsLst(ClsLst,Klanz,ClSlct);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Statistical Model');
      GtWrFileNameG(100,100,StModPfad,StModSvDatei);;
      if not Leer(StModSvDatei) then
         if EmpModActive then SaveStMod(StModSvDatei,EmpMod,OK)
                         else SaveStMod(StModSvDatei,StMod,OK);
      ClrDskTpG(ActPage);
      end;
   7: begin
      GtWrFileNameG(100,100,StModPfad,EdiDatei);
      RestoreCrtMode;
      SwapVectors;
      Exec(EditorPfad,EdiDatei);
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      ClrDskTpG(ActPage);
      end;
   8: begin
      Message('Determine Random Generator Seedpoint');
      GetWertI('RandSeedInit : ',RandSeedInit);
      ClrDskTpG(ActPage);
      end;
   9: begin
      Message('Initialize Random Generator');
      RandSeed:=RandSeedInit;
      Delay(500);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteStMod=10;
 end;


procedure KoorKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysKoor,TasteKoor);
  case TasteKoor of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      EditMskG(KoorMaske,OK,rm);
      ClrDskTpG(ActPage);
      KoorInit(KoorMaske.erg,Koor);
      end;
   3: begin
      Message('Select Inputfile Coordinate System');
      GtRdFileNameG(100,100,KoorPfad,KoorRdDatei);
      if not Leer(KoorRdDatei) then begin
                                    LoadMsk(KoorRdDatei,KoorMaske,OK);
                                    KoorInit(KoorMaske.erg,Koor);
                                    end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Coordinate System');
      GtWrFileNameG(100,100,KoorPfad,KoorSvDatei);
      if not Leer(KoorSvDatei) then SaveMsk(KoorSvDatei,KoorMaske,OK);
      ClrDskTpG(ActPage);
      end;
   5: begin
      {if ZchFld=scrn then ZchFld:=hcop else ZchFld:=scrn;
      KeysKoor[5]:=ZchFldStr(ZchFld);
      ZchFldInit;}
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteKoor=10;
 end;


procedure PlotKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPlot,TastePlot);
  case TastePlot of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  for i:=1 to ModPar^.anz do
                   if (ClSlct=[]) or (ModPar^.par[i].class in ClSlct) then
                    begin
                    if HauptachsenColor=255 then SetColor(ModPar^.par[i].color)
                                            else SetColor(HauptachsenColor);
                    SetLineStyle(SolidLn,0,HauptachsenLnWdth);
                    PlotHauptAchse(i);
                    end;
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   3: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  for i:=1 to ModPar^.anz do
                   if (ClSlct=[]) or (ModPar^.par[i].class in ClSlct) then
                   begin
                   if EllipsenColor=255 then SetColor(ModPar^.par[i].color)
                                        else SetColor(EllipsenColor);
                   for j:=1 to EllipsenAnz do
                    begin
                    l_art:=Lmuster[1+j mod 2];
                    wert:=Ellipsenwert[j];
                    case Ellipsentyp of
                     'Q': begin end;
                     'R': wert:=-2*ln(wert);
                     'P': wert:=-2*ln(wert/ModPar^.par[i].pmax);
                     'D': wert:=-2*ln(wert/ModPar^.par[i].dmax);
                    end;
                    if wert>0 then PlotAequivElli(i,wert);
                    end;
                  end;
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   4: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  l_art:=LMuster[ModellGrenzenLineStyle];
                  SetColor(ModellGrenzencolor);
                  for i:=1 to ModPar^.anz do
                   if (ClSlct=[]) or (ModPar^.par[i].class in ClSlct) then
                    for j:=i+1 to ModPar^.anz do
                     if ((ClSlct=[]) or (ModPar^.par[j].class in ClSlct))
                        and (ModPar^.par[i].class<>ModPar^.par[j].class) then
                         PlotModellGrenze(i,j);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   5: begin
      RelevanteGrenzen:= not RelevanteGrenzen;
      if RelevanteGrenzen then KeysPlot[5]:='RLV_BD'
                          else KeysPlot[5]:='ALL_BD';
      end;
   6: begin
      if Leer(ProSvDatei) then begin
                               ErrorMessage('No Protocol File available');
                               WaitForReturn;
                               ClrDsktpG(ActPage);
                               end
      else if not (ClsfMode in [1,2]) then
                               begin
                               ErrorMessage('Activate Mode MD_CLF oder MD_NNT');
                               WaitForReturn;
                               ClrDsktpG(ActPage);
                               end
      else begin
           WrPro:= not WrPro;
           if WrPro then KeysPlot[6]:='   PRO'
                    else KeysPlot[6]:='NO_PRO';
           end;
      end;
   7: begin
      case ClsfMode of
       0: if KlfDatFertig then ClsfMode:=1
          else if NntDatFertig then ClsfMode:=2
               else begin
                    ErrorMessage('No Classifier or MLP-Network available');
                    WaitForReturn;
                    end;
       1: if NntDatFertig then Clsfmode:=2 else ClsfMode:=0;
       2: ClsfMode:=0;
      end;
      case ClsfMode of
       0: begin KeysPlot[7]:='MODE 0'; Classify:=False; end;
       1: begin KeysPlot[7]:='MD_CLF'; Classify:=True;  end;
       2: begin KeysPlot[7]:='MD_NNT'; Classify:=True;  end;
      end;
      ClrDsktpG(ActPage);
      end;
   8: begin
      if WrSmpl         then begin
                             Assign(StchpSvFile,StchpSvDatei);
                             ReWrite(StchpSvFile);
                             end;
      if WrDvkt         then begin
                             Assign(DVektSvFile,DVektSvDatei);
                             ReWrite(DVektSvFile);
                             end;
      if SmplSrcMod     then StchpSrc:='Modell'
                        else begin
                             StchpSrc:=StchpRdDatei;
                             Assign(StchpRdFile,StchpRdDatei);
                             ReSet(StchpRdFile);
                             end;
      if WrPro          then begin
                             Assign(ProSvFile,ProSvDatei);
                             ReWrite(ProSvFile);
                             ProtokollKopf;
                             end;
      if SmplCount      then ClrClCnt;
      if SmplMom        then ClearMom;
      if Classify
         and AkkStat         then ClearStatistik;
      if Lernen
         and (ClsfMode=1)    then InitHDiagInv;
      if WrPro or ShPro      then begin
                                  SumRadQ:=0;
                                  SumErr:= 0;
                                  for i:=1 to Klanz do SumDeltaD[i]:=0;
                                  end;

      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  SmplNr:=0; AnzSmpl:=0; StchpEnde:=False;
                  while not StchpEnde and (AnzSmpl<StAnz) do
                   begin
                   GetNxtSmplNnt(v,StchpEnde);
                   end;
                  if not SmplSrcMod then Close(StchpRdFile);
                  if WrSmpl         then begin
                                         Close(StchpSvFile);
                                         WrSmpl:=False;
                                         end;
                  if WrDVkt         then begin
                                         Close(DVektSvFile);
                                         WrDVkt:=False;
                                         end;
                  if WrPro          then begin
                                         Close(ProSvFile);
                                         WrPro:=False;
                                         KeysPlot[6]:='NO_PRO';
                                         end;
                  if Classify
                     and AkkStat    then StatistikFertig:=True;

      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  if SmplCount then begin
                                    ShwClCnt;
                                    WaitForReturn;
                                    ClrDsktpG(ActPage);
                                    end;
                  if SmplMom   then begin
                                    CmpltMom;
                                    MakeEmpMod(EmpMod);
                                    EmpModFertig:=True;
                                    if not Leer(MomSvDatei) then
                                     SaveEmpMod(MomSvDatei,MomDat,OK);
                                    end;
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;

  end;
 until TastePlot=10;
 end;


procedure MainKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysMain,TasteMain);
  case TasteMain of
   1: PlotKeys;
   2: KoorKeys;
   3: StModKeys;
   4: StchpKeys;
   5: RekKeys;
   6: KlfKeys;
   7: ParamKeys;
   8: begin
      RestoreCrtMode;
      SwapVectors;
      Exec(Editorpfad,'');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      ClrDskTpG(ActPage);
      end;
   9: begin
      w:=DskTpColor[ActPage];
      DskTpColor[ActPage]:=Black;
      ClrDskTpG(ActPage);
      RestoreCrtMode;
      SwapVectors;
      Exec('C:\COMMAND.COM','');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      DskTpColor[ActPage]:=w;
      ClrDskTpG(ActPage);
      end;
  end;
  until TasteMain=10;
 end;


begin
DetectGraph(GrDr,GrMd); GrMd:=1;
DtctGrphPar(ChrW,ChrH,AnzPxH,AnzPxV);
BGIPfad:=GetEnv('BGIPFAD');
InitGraph(GrDr,GrMd,BGIPfad);
MouseReset;
Randomize;

ZchFld:=scrn;     {KeysKoor[5]:= ZchFldStr(ZchFld);}   ZchFldInit;
PltSmpl:=1;        KeysStchp[1]:=PltSmplStr(PltSmpl);

WrPro:=False;      KeysPlot[6] :='NO_PRO';
ClsfMode:=0;       KeysPlot[7] :='MODE_0';
Lernen:=False;     KeysRek[6]  :='NOLEAR';
ShPro:=False;      KeysRek[7]  :='SH_NOT';
FirstLayerNode:=0; KeysNntPl[5]:='   All';
AlphaCon:=True;    KeysNntMk[7]:='ALPCON';


StAnz:=            100000;

SmplSrcMod:=       True;
WrSmpl:=           False;
WrDvkt:=           False;
SmplZykl:=         False;
SmplCount:=        False;
SmplMom:=          False;
RelevanteGrenzen:= True;
HyperbelStep:=     0.1;
EmpModActive:=     False;
EmpModFertig:=     False;
ClrClCnt;
Strat:=            ms;
MinDiag:=          0.0001;
DsplMom:=          False;
MomMatFertig:=     False;
KlfDatFertig:=     False;
Classify:=         False;
DsplErkErg:=       False;
SnglStp:=          False;
OutlSchw:=         4.0;
GlbwSchw:=         0.7;
RadqSchw:=         1.0;
Block:=            5;
SlctCode:=         15;
AkkStat:=          False;
StatistikFertig:=  False;
StatColor:=        Red;
StatLineStyle:=    0;
BeschrColor:=      White;
Index1:=           0;
Index2:=           0;
Stchp40:=          False;

StepPro:=          1000;
ProSvDatei:=       '';

InitGew:=          0.2;
AlphaNnt:=         0.05;
AlphaKlf:=         0.001;
NntDatFertig:=     False;

RandSeedInit:=     1;

AlphaZykl:=        StepPro;
AlphaFak:=         0.5;
AlphaMin:=         0.1*AlphaNnt;


Netz.AnzModuls:=          1;
Netz.NntModul[1].AnzIn:=  2;
NntFirstLColor:=          LightGray;
NntFirstLLineStyle:=      1;

PfadePfad:=  '*.MSK';
PfadeRdDflt:='PFADNNT.MSK';
KoorRdDflt:= 'KOORSTM.MSK';
StModRdDflt:='M012_A.MOD';
FarbeRdDflt:='FARBNNT.MSK';
StchpRdDflt:='M012_A.STI';


LoadMsk(PfadeRdDflt,PfadeMaske,OK);
 if not OK then WriteXYG(100,100,PfadeRdDflt+' not found')
           else PfadeInitNnt(PfadeMaske);
LoadMsk(KoorRdDatei,KoorMaske,OK);
 if not OK then WriteXYG(100,110,KoorRdDatei+' not found')
           else KoorInit(KoorMaske.erg,Koor);
LoadStMod(StModRdDatei,StMod,OK);
 if not OK then WriteXYG(100,120,StModRdDatei+' not found')
           else begin
                StModInit(StMod);
                ClsLstFromStMod(StMod,ClsLst,KlAnz);
                ClSlctFromClsLst(ClsLst,Klanz,ClSlct);
                end;
LoadMsk(FarbeRdDatei,FarbeMaske,OK);
 if not OK then WriteXYG(100,130,FarbeRdDatei+' not found')
           else ColorInitNnt(FarbeMaske);


ActPage:=1; {Grafikseite}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);
ActPage:=0; {Textseite im Grafikmode}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);

Titel('NNT');

while WaitForReturnOrEscape do begin
                               ActPage:=0; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                                           ClrDsktpG(ActPage);
                                           MainKeys;
                               ActPage:=1; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                               end;
Closegraph;
end.
