program PLOTREKe;

{$M 16000,0,40000}


Uses
 graph,dos,crt,
 js_sub,js_acc,js_key,js_tio,js_fio,js_koor,
 js_mtr,js_gra,pc_mouse,js_mat,js_pltr;

Var
 w:          Word;
 s:          String;

 PfadeMaske:  MskPar_T;
 KoorMaske:   MskPar_T;
 FarbeMaske:  MskPar_T;

 TasteMain       : FktTst;
   TasteKoor     : FktTst;
   TasteRst      : FktTst;
   TasteErr      : FktTst;
   TasteDel      : FktTst;
   TasteParam    : FktTst;
     TastePfade  : FktTst;
     TasteFarbe  : FktTst;



Const
 KeysMain:   KeyTxt =('Main',
                      '->COOR','-> RSV','-> ERR','-> DEL','      ',
                      'RD_PRO','->PARA','-> EDI','-> DOS','IMGEXT');

 KeysKoor:   KeyTxt =('Coor',
                      '  PLOT','  EDIT','LD_COO','SV_COO','      ',
                      '      ','      ',' IMAGE',' CLEAR','MAIN<-');

 KeysRst:    KeyTxt =('ResVar',
                      '  COOR','LD_COO','PL_RSV','      ','      ',
                      ' IMAGE','LCOLOR','LSTYLE',' CLEAR','MAIN<-');

 KeysErr:    KeyTxt =('Error',
                      '  COOR','LD_COO','PL_ERR','      ','      ',
                      ' IMAGE','LCOLOR','LSTYLE',' CLEAR','MAIN<-');

 KeysDel:    KeyTxt =('DeltaD',
                      '  COOR','LD_COO','PL_DEL','      ','      ',
                      ' IMAGE','LCOLOR','LSTYLE',' CLEAR','MAIN<-');

 KeysParam:  KeyTxt =('Param',
                      '->PATH','->COLS','WCOLOR','WRTIMG','      ',
                      '......','......','      ','      ','MAIN<-');

 KeysPfade:  KeyTxt =('Paths',
                      '      ','  EDIT','LD_PFD','SV_PFD','      ',
                      '      ','      ','      ','      ','PARA<-');

 KeysFarbe:  KeyTxt =('Colors',
                      '      ','  EDIT','LD_FRB','SV_FRB','      ',
                      '      ','      ','      ','      ','PARA<-');





procedure PfadeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPfade,TastePfade);
  case TastePfade of
   2: begin
      EditMskG(PfadeMaske,OK,rm);
      PfadeInitPltrek(PfadeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Paths and Defaults');
      GtRdFileNameG(100,100,PfadePfad,PfadeRdDatei);
      if not Leer(PfadeRdDatei) then begin
                                     LoadMsk(PfadeRdDatei,PfadeMaske,OK);
                                     PfadeInitPltrek(PfadeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Paths and Defaults');
      GtWrFileNameG(100,100,PfadePfad,PfadeSvDatei);
      if not Leer(PfadeSvDatei) then SaveMsk(PfadeSvDatei,PfadeMaske,OK);
      ClrDskTpG(ActPage);
      end;
  end;
 until TastePfade=10;
 end;


procedure FarbeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysFarbe,TasteFarbe);
  case TasteFarbe of
   2: begin
      EditMskG(FarbeMaske,OK,rm);
      ColorInitPltrek(FarbeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Presentation Parameters');
      GtRdFileNameG(100,100,FarbePfad,FarbeRdDatei);
      if not Leer(FarbeRdDatei) then begin
                                     LoadMsk(FarbeRdDatei,FarbeMaske,OK);
                                     ColorInitPltrek(FarbeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Presentation Parameters');
      GtWrFileNameG(100,100,FarbePfad,FarbeSvDatei);
      if not Leer(FarbeSvDatei) then SaveMsk(FarbeSvDatei,FarbeMaske,OK);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteFarbe=10;
 end;


procedure ParamKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysParam,TasteParam);
  case TasteParam of
   1: PfadeKeys;
   2: FarbeKeys;
   3: begin
      repeat
       s:=ColorToStr(BeschrColor);
       OvWrt:=True;
       GetStr('Color for Writing Text in Image: ',12,s);
       BeschrColor:=ColorFromStr(s);
      until BeschrColor<=15;
      ClrDskTpG(ActPage);
      end;
   4: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  TextColor(BeschrColor);
                  TextBackGround(DsktpColor[ActPage]);
                  Beschrifte;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   6: begin
      IncColor:=not IncColor;
      if IncColor then KeysParam[6]:='INCCOL'
                  else KeysParam[6]:='FIXCOL'
      end;
   7: begin
      IncLnArt:=not IncLnArt;
      if IncLnArt then KeysParam[7]:='INCSTY'
                  else KeysParam[7]:='FIXSTY'
      end;
  end;
 until TasteParam=10;
 end;


procedure KoorKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysKoor,TasteKoor);
  case TasteKoor of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      EditMskG(KoorMaske,OK,rm);
      ClrDskTpG(ActPage);
      KoorInit(KoorMaske.erg,Koor);
      end;
   3: begin
      Message('Select Inputfile Coordinate System');
      GtRdFileNameG(100,100,KoorPfad,KoorRdDatei);
      if not Leer(KoorRdDatei) then begin
                                    LoadMsk(KoorRdDatei,KoorMaske,OK);
                                    KoorInit(KoorMaske.erg,Koor);
                                    end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Coordinate System');
      GtWrFileNameG(100,100,KoorPfad,KoorSvDatei);
      if not Leer(KoorSvDatei) then SaveMsk(KoorSvDatei,KoorMaske,OK);
      ClrDskTpG(ActPage);
      end;
   5: begin
      {if ZchFld=scrn then ZchFld:=hcop else ZchFld:=scrn;
      KeysKoor[5]:=ZchFldStr(ZchFld);
      ZchFldInit;}
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteKoor=10;
 end;


procedure RstKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysRst,TasteRst);
  case TasteRst of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      Message('Select Inputfile Coordinate System');
      GtRdFileNameG(100,100,KoorPfad,KoorRdDatei);
      if not Leer(KoorRdDatei) then begin
                                    LoadMsk(KoorRdDatei,KoorMaske,OK);
                                    KoorInit(KoorMaske.erg,Koor);
                                    end;
      ClrDskTpG(ActPage);
      end;
   3: begin
      if Not ProFertig then ErrorMessage('No Protocol File available')
       else
        begin
        ActPage:=1; SetActivePage(ActPage);
                    SetColor(RstLineColor);
                    L_Art:=LMuster[RstLineArt];
                    PlotRst;
                    If IncColor then begin
                                     RstLineColor:=(RstLinecolor+1) Mod 16;
                                     if RstLineColor=DsktpColor[1] then Inc(RstLineColor);
                                     end;
                    If IncLnArt then RstLineArt:=(RstLineArt+1) Mod 10;
                    SetVisualPage(ActPage);
        WaitforReturn;
        ActPage:=0; SetActivePage(ActPage);
                    SetVisualPage(ActPage);
        end;
      end;
   6: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   7: begin
      repeat
       s:=ColorToStr(RstLineColor);
       OvWrt:=True;
       GetStr('Line Color ResVar: ',12,s);
       RstLineColor:=ColorFromStr(s);
      until BeschrColor<=15;
      ClrDskTpG(ActPage);
      end;
   8: begin
      repeat
       OvWrt:=True;
       GetWertI('Line Style ResVar: ',RstLineArt);
      until RstLineArt in [0..9];
      ClrDskTpG(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;

  end;
 until TasteRst=10;
 end;


procedure ErrKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysErr,TasteErr);
  case TasteErr of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      Message('Select Inputfile Coordinate System');
      GtRdFileNameG(100,100,KoorPfad,KoorRdDatei);
      if not Leer(KoorRdDatei) then begin
                                    LoadMsk(KoorRdDatei,KoorMaske,OK);
                                    KoorInit(KoorMaske.erg,Koor);
                                    end;
      ClrDskTpG(ActPage);
      end;
   3: begin
      if Not ProFertig then ErrorMessage('No Protocol File available')
       else
        begin
        ActPage:=1; SetActivePage(ActPage);
                    SetColor(ErrLineColor);
                    L_Art:=LMuster[ErrLineArt];
                    PlotErr;
                    If IncColor then begin
                                     ErrLineColor:=(ErrLinecolor+1) Mod 16;
                                     if ErrLineColor=DsktpColor[1] then Inc(ErrLineColor);
                                     end;
                    If IncLnArt then ErrLineArt:=(ErrLineArt+1) Mod 10;
                    SetVisualPage(ActPage);
        WaitforReturn;
        ActPage:=0; SetActivePage(ActPage);
                    SetVisualPage(ActPage);
        end;
      end;
   6: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   7: begin
      repeat
       s:=ColorToStr(ErrLineColor);
       OvWrt:=True;
       GetStr('Line Color Error: ',12,s);
       ErrLineColor:=ColorFromStr(s);
      until BeschrColor<=15;
      ClrDskTpG(ActPage);
      end;
   8: begin
      repeat
       OvWrt:=True;
       GetWertI('Line Style Error: ',ErrLineArt);
      until ErrLineArt in [0..9];
      ClrDskTpG(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;

  end;
 until TasteErr=10;
 end;


procedure DelKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysDel,TasteDel);
  case TasteDel of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      Message('Select Inputfile Coordinate System');
      GtRdFileNameG(100,100,KoorPfad,KoorRdDatei);
      if not Leer(KoorRdDatei) then begin
                                    LoadMsk(KoorRdDatei,KoorMaske,OK);
                                    KoorInit(KoorMaske.erg,Koor);
                                    end;
      ClrDskTpG(ActPage);
      end;
   3: begin
      if Not ProFertig then ErrorMessage('No Protocol File available')
       else
        begin
        ActPage:=1; SetActivePage(ActPage);
                    SetColor(DelLineColor);
                    L_Art:=LMuster[DelLineArt];
                    PlotDel;
                    If IncColor then begin
                                     DelLineColor:=(DelLinecolor+1) Mod 16;
                                     if DelLineColor=DsktpColor[1] then Inc(DelLineColor);
                                     end;
                    If IncLnArt then DelLineArt:=(DelLineArt+1) Mod 10;
                    SetVisualPage(ActPage);
        WaitforReturn;
        ActPage:=0; SetActivePage(ActPage);
                    SetVisualPage(ActPage);
        end;
      end;
   6: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   7: begin
      repeat
       s:=ColorToStr(DelLineColor);
       OvWrt:=True;
       GetStr('Line Color DeltaDQ: ',12,s);
       DelLineColor:=ColorFromStr(s);
      until BeschrColor<=15;
      ClrDskTpG(ActPage);
      end;
   8: begin
      repeat
       OvWrt:=True;
       GetWertI('Line Style DeltaDQ: ',DelLineArt);
      until DelLineArt in [0..9];
      ClrDskTpG(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;

  end;
 until TasteDel=10;
 end;


procedure MainKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysMain,TasteMain);
  case TasteMain of
   1: KoorKeys;
   2: RstKeys;
   3: ErrKeys;
   4: DelKeys;
   6: begin
      Message('Select Inputfile Protocol');
      GtRdFileNameG(100,100,ProPfad,ProRdDatei);
      if not Leer(ProRdDatei) then begin
                                   RdPro(ProRdDatei);
                                   ProFertig:=True;
                                   end;
      ClrDskTpG(ActPage);
      end;
   7: ParamKeys;
   8: begin
      RestoreCrtMode;
      SwapVectors;
      Exec(Editorpfad,'');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      ClrDskTpG(ActPage);
      end;
   9: begin
      w:=DskTpColor[ActPage];
      DskTpColor[ActPage]:=Black;
      ClrDskTpG(ActPage);
      RestoreCrtMode;
      SwapVectors;
      Exec('C:\COMMAND.COM','');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      DskTpColor[ActPage]:=w;
      ClrDskTpG(ActPage);
      end;
  end;
  until TasteMain=10;
 end;


begin
DetectGraph(GrDr,GrMd); GrMd:=1;
DtctGrphPar(ChrW,ChrH,AnzPxH,AnzPxV);
BGIPfad:=GetEnv('BGIPFAD');
InitGraph(GrDr,GrMd,BGIPfad);
MouseReset;

ZchFld:=scrn; {KeysKoor[5]:= ZchFldStr(ZchFld);}   ZchFldInit;
IncColor:=False; KeysParam[6]:='FIXCOL';
IncLnArt:=False; KeysParam[7]:='FIXSTY';
ProFertig:=False;

BeschrColor:= White;

PfadePfad:=  '*.MSK';
PfadeRdDflt:='PFADPLR.MSK';
KoorRdDflt:= 'KOORPLR.MSK';
FarbeRdDflt:='FARBPLR.MSK';


LoadMsk(PfadeRdDflt,PfadeMaske,OK);
 if not OK then WriteXYG(100,100,PfadeRdDflt+' not found')
           else PfadeInitPltrek(PfadeMaske);
LoadMsk(KoorRdDatei,KoorMaske,OK);
 if not OK then WriteXYG(100,110,KoorRdDatei+' not found')
           else begin
                KoorInit(KoorMaske.erg,Koor);
                end;
LoadMsk(FarbeRdDatei,FarbeMaske,OK);
 if not OK then WriteXYG(100,130,FarbeRdDatei+' not found')
           else ColorInitPltrek(FarbeMaske);



ActPage:=1; {Grafikseite}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);
ActPage:=0; {Textseite im Grafikmode}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);



Titel('PLOTREK');

while WaitForReturnOrEscape do begin
                               ActPage:=0; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                                           ClrDsktpG(ActPage);
                                           MainKeys;
                               ActPage:=1; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                               end;
Closegraph;
end.
