program proje;

{$M 32768,0,100000}

Uses
 graph,dos,crt,
 js_sub,js_acc,js_key,js_tio,js_fio,
 js_koor,js_stm,js_mtr,js_gra,pc_mouse,js_proj,js_nnt,
 matrix,js_zepas;



Var
 ch:          Char;
 k:           Word;
 w:           Word;
 v:           Vector_2;
 s,sc:        String;
 f:           Text;

 StMod:      StMod_T;

 PfadeMaske: MskPar_T;
 KoorMaske:  MskPar_T;
 Koor3D:     MskPar_T;
 ProjPar:    MskPar_T;
 PlotPar:    MskPar_T;
 FarbeMaske: MskPar_T;

 TasteMain     : FktTst;
  TastePlot    : FktTst;
  TasteKoor    : FktTst;
  TasteProj    : FktTst;
  TastePlotDat : FktTst;
  TasteKlf     : FktTst;
  TasteNnt     : FktTst;
  TasteStMod   : FktTst;
  TasteParam   : FktTst;
    TastePfade : FktTst;
    TasteFarbe : FktTst;


Const
 KeysMain:    KeyTxt =('Main',
                       '->PLOT','->COOR','->PROJ','-> PLD','-> CLF',
                       '-> NNT','->STMD','->PARA','-> DOS','IMGEXT');

 KeysPlot:    KeyTxt =('Plot',
                       '  COOR','COOR3D','  PLOT','  GRID','      ',
                       '......','......',' IMAGE',' CLEAR','MAIN<-');

 KeysKoor:    KeyTxt =('Coor3D',
                       '  PLOT','  EDIT','LD_COO','SV_COO','      ',
                       '      ','      ',' IMAGE',' CLEAR','MAIN<-');

 KeysProj:    KeyTxt =('PrjPar',
                       '      ','ED_PRJ','LD_PRJ','SV_PRJ','      ',
                       'ED_PLP','LD_PLP','SV_PLP','      ','MAIN<-');

 KeysPlotDat: KeyTxt =('PltDat',
                       '      ','      ','LD_PLD','SV_PLD','  CLIP',
                       '  SKAL','  MANU','      ','      ','MAIN<-');

 KeysKlf:     KeyTxt =('Clf',
                       'RADQTH','SELECT','LD_CLF','DISPLD','ALTPLD',
                       'DISCTH','RADPLD','  MANU','  CLIP','MAIN<-');

 KeysNnt:     KeyTxt =('Nnt',
                       'RADQTH','SELECT','LD_NNT','DISPLD','      ',
                       'DISCTH','      ','  MANU','  CLIP','MAIN<-');

 KeysStMod:   KeyTxt =('StMod',
                       '      ','SELECT','LD_MOD','      ','MODPLD',
                       '  SCAL','  MANU','WIDFCT','      ','MAIN<-');

 KeysParam:   KeyTxt =('Param',
                       '->PATH','->COLS','WCOLOR','WRTIMG','......',
                       'LD_CNF','......','......','      ','MAIN<-');

 KeysPfade:   KeyTxt =('Paths',
                       '      ','ED_PFD','LD_PFD','SV_PFD','      ',
                       '......','      ','      ','      ','PARA<-');

 KeysFarbe:   KeyTxt =('Colors',
                       '      ','ED_FRB','LD_FRB','SV_FRB','      ',
                       '      ','      ','      ','      ','PARA<-');




procedure PlotKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPlot,TastePlot);
  case TastePlot of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(Koor3DColor);
                  l_art:=LMuster[Koor3DLineStyle];
                  PlotKoor3D(Achslaenge,Ursprung);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   3: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  SetColor(PlotFktColor);
                  l_art:=LMuster[PlotFktLineStyle];
                  Plot3D(Achslaenge,Ursprung);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   4: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(RasterColor);
                  l_art:=LMuster[RasterLineStyle];
                  Raster(Achslaenge,Ursprung);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   5: begin
      HightLines:=not HightLines;
      if HightLines then KeysPlot[5]:='  HILI'
                    else KeysPlot[5]:='NOHILI';
      end;
   6: begin
      Hide:=not Hide;
      if Hide then KeysPlot[6]:='  HIDE'
              else KeysPlot[6]:='NOHIDE';
      end;
   7: begin
      PosZAchse:=(PosZAchse+1) mod 4;
      case PosZAchse of
       0: KeysPlot[7]:='Z fron';
       1: KeysPlot[7]:='Z left';
       2: KeysPlot[7]:='Z back';
       3: KeysPlot[7]:='Z righ';
      end;
      end;
   8: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
    9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
                  ClrUmriss;
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TastePlot=10;
 end;


procedure KoorKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysKoor,TasteKoor);
  case TasteKoor of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(Koor3DColor);
                  l_art:=LMuster[Koor3DLineStyle];
                  PlotKoor3D(Achslaenge,Ursprung);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      EditMskG(Koor3D,OK,rm);
      ClrDskTpG(ActPage);
      Koor3DInit(Koor3D);
      case PosZAchse of
       0: KeysPlot[7]:='Z fron';
       1: KeysPlot[7]:='Z left';
       2: KeysPlot[7]:='Z back';
       3: KeysPlot[7]:='Z righ';
      end;

      end;
   3: begin
      Message('Select Inputfile 3D-Coordinate System');
      GtRdFileNameG(100,100,KoorPfad,Koor3DRdDatei);
      if not Leer(Koor3DRdDatei) then begin
                                      LoadMsk(Koor3DRdDatei,Koor3D,OK);
                                      Koor3DInit(Koor3D);
                                      case PosZAchse of
                                       0: KeysPlot[7]:='Z vorn';
                                       1: KeysPlot[7]:='Z lnks';
                                       2: KeysPlot[7]:='Z hntn';
                                       3: KeysPlot[7]:='Z rcht';
                                      end;
                                      end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile 3D-Coordinate System');
      GtWrFileNameG(100,100,KoorPfad,Koor3DSvDatei);
      if not Leer(Koor3DSvDatei) then SaveMsk(Koor3DSvDatei,Koor3D,OK);
      ClrDskTpG(ActPage);
      end;
   5: begin
      {if ZchFld=scrn then ZchFld:=hcop else ZchFld:=scrn;
      KeysKoor[5]:=ZchFldStr(ZchFld);
      ZchFldInit;}
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
                  ClrUmriss;
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteKoor=10;
 end;


procedure ProjParKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysProj,TasteProj);
  case TasteProj of
   2: begin
      EditMskG(ProjPar,OK,rm);
      ProjParInit(ProjPar);
      if Hide then KeysPlot[6]:='  HIDE'
              else KeysPlot[6]:='NOHIDE';
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Projektion Parameters');
      GtRdFileNameG(100,100,PrjPfad,ProjParRdDatei);
      if not Leer(ProjParRdDatei) then begin
                                       LoadMsk(ProjParRdDatei,ProjPar,OK);
                                       ProjParInit(ProjPar);
                                       if Hide then KeysPlot[6]:='  HIDE'
                                               else KeysPlot[6]:='NOHIDE'
                                       end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Projektion Parameter');
      GtWrFileNameG(100,100,PrjPfad,ProjParSvDatei);
      if not Leer(ProjParSvDatei) then SaveMsk(ProjParSvDatei,ProjPar,OK);
      ClrDskTpG(ActPage);
      end;
   6: begin
      EditMskG(PlotPar,OK,rm);
      PlotParInit(PlotPar);
      ClrDskTpG(ActPage);
      end;
   7: begin
      Message('Select Inputfile Field of View Parameters');
      GtRdFileNameG(100,100,PlpPfad,PlotParRdDatei);
      if not Leer(PlotParRdDatei) then begin
                                       LoadMsk(PlotParRdDatei,PlotPar,OK);
                                       PlotParInit(PlotPar);
                                       end;
      ClrDskTpG(ActPage);
      end;
   8: begin
      Message('Select Outputfile Field of View Parameters');
      GtWrFileNameG(100,100,PlpPfad,PlotParSvDatei);
      if not Leer(PlotParSvDatei) then SaveMsk(PlotParSvDatei,PlotPar,OK);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteProj=10;
 end;



procedure PlotDatKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPlotDat,TastePlotDat);
  case TastePlotDat of
   3: begin
      Message('Select Inputfile Plotdata *.PLD');
      GtRdFileNameG(100,100,PldPfad,PlotDatRdDatei);
      if not Leer(PlotDatRdDatei) then begin
                                       LoadPlotDat(PlotDatRdDatei,PlotDat,OK);
                                       if not OK then
                                        LoadPlotDatMono(PlotDatRdDatei,PlotDat,OK);
                                       end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Plotdata *.PLD');
      GtWrFileNameG(100,100,PldPfad,PlotDatSvDatei);
      if not Leer(PlotDatSvDatei) then SavePlotDat(PlotDatSvDatei,PlotDat,OK);
      ClrDskTpG(ActPage);
      end;
   5: begin
      Message('Determine Clipping Thresholds: Bottom, Top');
      GetWertR('Clipping Threshold Bottom = ',ClipUnten);
      GetWertR('Clipping Threshold Top    = ',ClipOben );
      ClipPlotDat(ClipUnten,ClipOben);
      ClrDskTpG(ActPage);
      end;
   6: begin
      MaxPlotDat(ZMax);
      SkalPlotDat(1/ZMax);
      end;
   7: begin
      MaxPlotDat(ZMax);
      Message('Current Maximum Z-Value : '+StrR(ZMax,10,4));
      GetWertR('Determine Z-Range = ',WMax);
      ClrDskTpG(ActPage);
      end;
  end;
 until TastePlotDat=10;
 end;


procedure KlfKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysKlf,TasteKlf);
  case TasteKlf of
   1: begin
      Message('Square-of-Rad-Threshold, active for QMK');
      GetWertR('RadqThrsh = ',RadqSchw);
      ClrDskTpG(ActPage);
      end;
   2: begin
      Message('Selection of Classes');
      s:=SetToStr(ClSlct);
      GetStr('Select : ',50,s);
      SetFromStr(s,ClSlct);
      ColorListInit(ClSlct,ColorLst);
      ClrDskTpG(ActPage);
      end;
   3: begin
      case ModeKlf of
       stm: begin
            Message('Select Inputfile Classifier');
            GtRdFileNameG(100,100,KlfPfad,KlfRdDatei);
            if not Leer(KlfRdDatei) then
             begin
             LoadKlf(KlfRdDatei,KlfDat,OK);
             ClsLstFromKlfDat(KlfDat,ClsLst,Klanz);
             ClSlctFromClsLst(ClsLst,Klanz,ClSlct);
             CnfMap:=False; KeysParam[5]:='NO_CNF';
             ColorListInit(ClSlct,ColorLst);
             KlfGeladen:=OK;
             end;
            end;
      { zep: begin
            Message('Auswahl Zepas-Klassifikator-Eingabedatei');
            GtRdFileNameG(100,100,ZKlfPfad,ZKlfRdDatei);
            if not Leer(ZKlfRdDatei) then
             begin
             if Koeff<>Nil then dispose(Koeff,done);
             Klf:=new(ClfDat_P,InitLoad(ZKlfRdDatei));
               Psl:=   Klf^.PslDat;
               Klanz:= Klf^.Matrix^.col;
               for k:=1 to Klanz do ClsLst[k]:=Klf^.Classes[k];
               Koeff:=new(PMatrix,InitCopy(Klf^.Matrix));
               Koeff^.Transpose;
             dispose(Klf,done);

             if Radbas then
                begin
                if not ZRdbDatFertig then
                  begin
                  ErrorMessage('RdbDat fehlt');
                  WaitForReturn;
                  end
                 else
                  begin
                  if Psl.LengthMv<>RdbDat^.LengthPv then
                   begin
                   ErrorMessage('Klassifikator pat nicht zu RdbDat');
                   ZKlfDatFertig:=False;
                   WaitForReturn;
                   end
                   else ZKlfDatFertig:=True;
                  end;
                end
              else
                begin
                if Psl.LengthMv<>2 then
                   begin
                   ErrorMessage('Klassifikator ist nicht fr dim[v]=2');
                   ZKlfDatFertig:=False;
                   WaitForReturn;
                   end
                  else ZKlfDatFertig:=True;
                end;

             CnfMap:=False; KeysParam[5]:='NO_CNF';
             ClSlctFromClsLst(ClsLst,Klanz,ClSlct);
             ColorListInit(ClSlct,ColorLst);
             end;
            end;}
      end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      if not (KlfGeladen     or
              ZKlfDatFertig) then
                              begin
                              ErrorMessage('No Classifier available');
                              WaitForReturn;
                              ClrDskTpG(ActPage);
                              end
                             else GenPlotDatFromKlf(ClSlct);
      end;
   5: begin
      if not (KlfGeladen     or
              ZKlfDatFertig) then
                              begin
                              ErrorMessage('No Classifier available');
                              WaitForReturn;
                              ClrDskTpG(ActPage);
                              end
                             else
                              begin
                              GenPlotDatAltFromKlf(GlbwSchw);
                              WMax:=10;
                              end;
      end;
   6: begin
      Message('Confidence-Threshold for Generation of Alternatives');
      GetWertR('GlbwThrsh = ',GlbwSchw);
      ClrDskTpG(ActPage);
      end;
   7: begin
      if not (KlfGeladen     or
              ZKlfDatFertig) then
                              begin
                              ErrorMessage('No Classifier available');
                              WaitForReturn;
                              ClrDskTpG(ActPage);
                              end
                             else
                              begin
                              GenPlotDatRadFromKlf;
                              ClipPlotDat(0,1);
                              WMax:=2;
                              end;
      end;
   8: begin
      MaxPlotDat(ZMax);
      Message('Current Maximum Z-Value : '+StrR(ZMax,10,4));
      GetWertR('Determine Z-Range = ',WMax);
      ClrDskTpG(ActPage);
      end;
   9: begin
      Message('Determine Clipping Thresholds: Bottom, Top');
      GetWertR('Clipping Threshold Bottom = ',ClipUnten);
      GetWertR('Clipping Threshold Top    = ',ClipOben );
      ClipPlotDat(ClipUnten,ClipOben);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteKlf=10;
 end;


procedure NntKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysNnt,TasteNnt);
  case TasteNnt of
   1: begin
      Message('Square-of-Rad-Threshold, active for QMK');
      GetWertR('RadqThrsh = ',RadqSchw);
      ClrDskTpG(ActPage);
      end;
   2: begin
      Message('Selection of Classes');
      s:=SetToStr(ClSlct);
      GetStr('Select : ',50,s);
      SetFromStr(s,ClSlct);
      ColorListInit(ClSlct,ColorLst);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile MLP Network');
      GtRdFileNameG(100,100,NntPfad,NntRdDatei);
      if not Leer(NntRdDatei) then
        begin
        LoadNnt(NntRdDatei,Netz,OK);
        ClsLstFromNnt(Netz,ClsLst,KlAnz);
        ClSlctFromClsLst(ClsLst,KlAnz,ClSlct);
        ColorListInit(ClSlct,ColorLst);
        InitNntVar(Netz);
        NntGeladen:=OK;
        end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      if not NntGeladen then begin
                             ErrorMessage('No MLP Network available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
                        else GenPlotDatFromNnt(ClSlct);
      end;
   6: begin
      Message('Confidence-Threshold for Generation of Alternatives');
      GetWertR('GlbwTrsh = ',GlbwSchw);
      ClrDskTpG(ActPage);
      end;
   8: begin
      MaxPlotDat(ZMax);
      Message('Current Maximum Z-Value : '+StrR(ZMax,10,4));
      GetWertR('Determine Z-Range = ',WMax);
      ClrDskTpG(ActPage);
      end;
   9: begin
      Message('Determine Clipping Thresholds: Bottom, Top');
      GetWertR('Clipping Threshold Bottom = ',ClipUnten);
      GetWertR('Clipping Threshold Top    = ',ClipOben );
      ClipPlotDat(ClipUnten,ClipOben);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteNnt=10;
 end;


procedure StModKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysStMod,TasteStMod);
  case TasteStMod of
   2: begin
      Message('Selection of Classes');
      s:=SetToStr(ClSlct);
      GetStr('Select : ',50,s);
      SetFromStr(s,ClSlct);
      ColorListInit(ClSlct,ColorLst);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Statistical Model');
      GtRdFileNameG(100,100,StModPfad,StModRdDatei);
      if not Leer(StModRdDatei) then begin
                                     LoadStMod(StModRdDatei,StMod,OK);
                                     WidenStMod(StMod);
                                     StModInit(StMod);
                                     NvtRefClssfr(ModPar,QmkDat);
                                     ClsLstFromKlfDat(QmkDat,ClsLst,KlAnz);
                                     ClSlctFromClsLst(ClsLst,KlAnz,ClSlct);
                                     ColorListInit(ClSlct,ColorLst);
                                     StModGeladen:=True;
                                     end;
      ClrDskTpG(ActPage);
      end;
   5: begin
      if not StModGeladen then begin
                               ErrorMessage('No Statistical Model available');
                               WaitForReturn;
                               ClrDskTpG(ActPage);
                               end
                          else GenPlotDatFromStMod(ClSlct);
      end;
   6: begin
      MaxPlotDat(ZMax);
      SkalPlotDat(1/ZMax);
      end;
   7: begin
      MaxPlotDat(ZMax);
      Message('Current Maximum Z-Value : '+StrR(ZMax,10,4));
      GetWertR('Determine Z-Range = ',WMax);
      ClrDskTpG(ActPage);
      end;
   8: begin
      Message('Widening Factor Main Axes, applied when loading Statistical Model');
      GetWertR('WidthFactor = ',WidthFak);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteStMod=10;
 end;


procedure PfadeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPfade,TastePfade);
  case TastePfade of
   2: begin
      OvWrt:=True;
      EditMskG(PfadeMaske,OK,rm);
      PfadeInitProj(PfadeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Paths and Defaults');
      GtRdFileNameG(100,100,PfadePfad,PfadeRdDatei);
      if not Leer(PfadeRdDatei) then begin
                                     LoadMsk(PfadeRdDatei,PfadeMaske,OK);
                                     PfadeInitProj(PfadeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Paths and Defaults');
      GtWrFileNameG(100,100,PfadePfad,PfadeSvDatei);
      if not Leer(PfadeSvDatei) then SaveMsk(PfadeSvDatei,PfadeMaske,OK);
      ClrDskTpG(ActPage);
      end;
   6: begin
      {if RdbTyp=clcprb then RdbTyp:=apoprb else RdbTyp:=Succ(RdbTyp);
      case RdbTyp of
       apoprb: KeysPfade[6]:='APOPRB';
       clcprb: KeysPfade[6]:='CLCPRB';
      end;}
      end;
  end;
 until TastePfade=10;
 end;


procedure FarbeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysFarbe,TasteFarbe);
  case TasteFarbe of
   2: begin
      EditMskG(FarbeMaske,OK,rm);
      ColorInitProj(FarbeMaske);
      ColorListInit(ClSlct,ColorLst);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Presentation Parameters');
      GtRdFileNameG(100,100,FarbePfad,FarbeRdDatei);
      if not Leer(FarbeRdDatei) then begin
                                     LoadMsk(FarbeRdDatei,FarbeMaske,OK);
                                     ColorInitProj(FarbeMaske);
                                     ColorListInit(ClSlct,ColorLst);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Presentation Parameters');
      GtWrFileNameG(100,100,FarbePfad,FarbeSvDatei);
      if not Leer(FarbeSvDatei) then SaveMsk(FarbeSvDatei,FarbeMaske,OK);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteFarbe=10;
 end;


procedure ParamKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysParam,TasteParam);
  case TasteParam of
   1: PfadeKeys;
   2: FarbeKeys;
   3: begin
      repeat
       s:=ColorToStr(BeschrColor);
       OvWrt:=True;
       GetStr('Color for Writing Text in Image: ',12,s);
       BeschrColor:=ColorFromStr(s);
      until BeschrColor<=15;
      ClrDskTpG(ActPage);
      end;
   4: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  TextColor(BeschrColor);
                  TextBackGround(DsktpColor[ActPage]);
                  Beschrifte;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   5: begin
      if not (KlfGeladen and GlbwDatFertig) then
       begin
       ErrorMessage('No Classifier and Confidence Mapping available');
       WaitForReturn;
       ClrDsktpG(ActPage);
       end
      else
      if CheckCompatKlfCnf then CnfMap:=not CnfMap else CnfMap:=False;
      if CnfMap then KeysParam[5]:='   CNF'
                else KeysParam[5]:='NO_CNF';
      end;
   6: begin
      Message('Select Inputfile Confidence Mapping');
      GtRdFileNameG(100,100,CnfPfad,CnfRdDatei);
      if not Leer(CnfRdDatei) then begin
                                   LoadGlbw(CnfRdDatei,OK);
                                   GlbwDatFertig:=True;
                                   CnfMap:=False; KeysParam[5]:='NO_CNF';
                                   end;
      ClrDskTpG(ActPage);
      end;
   7: begin
      {if ModeKlf=zep then ModeKlf:=stm else ModeKlf:=zep;
      case ModeKlf of
       stm: KeysParam[7]:='MD_KLF';
       zep: KeysParam[7]:='MD_ZEP';
      end;
      RadBas:=False; KeysParam[8]:='NO_RDB';}
      end;
   8: begin
      {If (ModeKlf=zep) and not RadBas then RadBas:=True else RadBas:=False;
      if RadBas then begin
                     KeysParam[8]:='   RDB';
                     Message('Eingabe Aufweitungsfaktor RdbFak');
                     GetWertR('RdbFak: ',RdbFak);
                     ClrDskTpG(ActPage);
                     end
                else KeysParam[8]:='NO_RDB';}
      end;
   9: begin
      {Message('Auswahl Zepas-RadBas-Eingabedatei');
      GtRdFileNameG(100,100,ZRdbPfad,ZRdbRdDatei);
      if not Leer(ZRdbRdDatei) then
       begin
       if ZRdbDatFertig then dispose(RdbDat,done);
       RdbDat:=New(RdbDat_P,InitLoad(ZRdbRdDatei,RdbFak));
       ZRdbDatFertig:=True;
       end;
      ClrDskTpG(ActPage);}
      end;
  end;
 until TasteParam=10;
 end;


procedure MainKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysMain,TasteMain);
  case TasteMain of
   1: PlotKeys;
   2: KoorKeys;
   3: ProjParKeys;
   4: PlotDatKeys;
   5: KlfKeys;
   6: NntKeys;
   7: StModKeys;
   8: ParamKeys;
   9: begin
      w:=DskTpColor[ActPage];
      DskTpColor[ActPage]:=Black;
      ClrDskTpG(ActPage);
      RestoreCrtMode;
      SwapVectors;
      Exec('C:\COMMAND.COM','');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      DskTpColor[ActPage]:=w;
      ClrDskTpG(ActPage);
      end;
   end;
  until TasteMain=10;
 end;




begin
DetectGraph(GrDr,GrMd); GrMd:=1;
DtctGrphPar(ChrW,ChrH,AnzPxH,AnzPxV);
BGIPfad:=GetEnv('BGIPFAD');
InitGraph(GrDr,GrMd,BGIPfad);
MouseReset;
New(PlotDat);

PfadePfad:=   '*.MSK';
PfadeRdDflt:= 'PFADPROJ.MSK';
KoorRdDflt:=  'KOORPROJ.MSK';
Koor3DRdDflt:='KOOR3D.MSK';
FarbeRdDflt:= 'FARBPROJ.MSK';

ZchFld:=scrn; {KeysKoor[5]:= ZchFldStr(ZchFld);} ZchFldInit;

LoadMsk(PfadeRdDflt,PfadeMaske,OK);
 if not OK then WriteXYG(100,100,PfadeRdDflt+' not found')
           else PfadeInitPROJ(PfadeMaske);
LoadMsk(KoorRdDatei,KoorMaske,OK);
 if not OK then WriteXYG(100,110,KoorRdDatei+' not found')
           else KoorInit(KoorMaske.erg,Koor);
LoadMsk(Koor3DRdDatei,Koor3D,OK);
 if not OK then WriteXYG(100,110,Koor3DRdDatei+' not found')
           else begin
                Koor3DInit(Koor3D);
                case PosZAchse of
                 0: KeysPlot[7]:='Z fron';
                 1: KeysPlot[7]:='Z left';
                 2: KeysPlot[7]:='Z back';
                 3: KeysPlot[7]:='Z righ';
                end;
                end;
LoadMsk(FarbeRdDatei,FarbeMaske,OK);
 if not OK then WriteXYG(100,130,FarbeRdDatei+' not found')
           else ColorInitPROJ(FarbeMaske);
LoadMsk(ProjParRdDatei,ProjPar,OK);
 if not OK then WriteXYG(100,130,ProjParRdDatei+' not found')
           else ProjParInit(ProjPar);
LoadMsk(PlotParRdDatei,PlotPar,OK);
 if not OK then WriteXYG(100,130,PlotParRdDatei+' not found')
           else PlotParInit(PlotPar);


CnfMap:=False;  KeysParam[5]:='NO_CNF';
ModeKlf:=stm;   KeysParam[7]:='      ';
RadBas:=False;  KeysParam[8]:='      ';
RdbTyp:=apoprb; KeysPfade[6]:='      ';


BeschrColor:=White;
ClipUnten:=0;
ClipOben:=1.0;
ClrUmriss;
KlfGeladen:=False;
StModGeladen:=False;
ZKlfDatFertig:=False;
ZRdbDatFertig:=False;
RdbFak:=1.0;
OutlSchw:=4.0;
RadqSchw:=2.0;
GlbwSchw:=0.7;
ClSlct:=[];
SlctLabel:=' ';
WidthFak:=1.0;


if Hide       then KeysPlot[6]:=   '  HIDE'
              else KeysPlot[6]:=   'NOHIDE';

if HightLines then KeysPlot[5]:=   '  HILI'
              else KeysPlot[5]:=   'NOHILI';

GenPlotDat;


ActPage:=1; {Grafikseite}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);
ActPage:=0; {Textseite im Grafikmode}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);

Titel('PROJ');

while WaitForReturnOrEscape do begin
                               ActPage:=0; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                                           ClrDsktpG(ActPage);
                                           MainKeys;
                               ActPage:=1; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                               end;

Dispose(PlotDat);
if ZKlfDatFertig then dispose(Koeff,done);
if ZRdbDatFertig then dispose(RdbDat,done);
Closegraph;
end.
