program QMYe;

{$M 16000,0,30000}


Uses
 graph,dos,crt,
 js_sub,js_acc,js_key,js_tio,js_fio,
 js_koor,js_stm,js_mtr,js_gra,pc_mouse,js_qmx,js_glbw,js_mdlh,js_qmy;



Var
 ch:          Char;
 n,k:         Word;
 w:           Word;
 s,sc:        String;


 PfadeMaske: MskPar_T;
 KoorMaske:  MskPar_T;
 FarbeMaske: MskPar_T;

 TasteMain     : FktTst;
  TastePlot    : FktTst;
  TasteKoor    : FktTst;
  TasteHist    : FktTst;
  TasteQMY     : FktTst;
  TasteParam   : FktTst;
    TastePfade : FktTst;
    TasteFarbe : FktTst;


Const
 KeysMain:  KeyTxt =('Main',
                     '->PLOT','->COOR','->HIST','-> QMY','      ',
                     'LD_CLF','->PARA','-> EDI','-> DOS','IMGEXT');

 KeysPlot:  KeyTxt =('Plot',
                     '  COOR','  PLOT','......','SELECT','PL_CNH',
                     'PL_CNF','PL_OUT',' IMAGE',' CLEAR','MAIN<-');

 KeysKoor:  KeyTxt =('Koor',
                     '  PLOT','  EDIT','LD_COO','SV_COO','      ',
                     '      ','      ',' IMAGE',' CLEAR','MAIN<-');

 KeysHist:  KeyTxt =('Hist',
                     'MKHIST','CL_LST','LD_HST','SV_HST','      ',
                     '......','      ','      ','      ','MAIN<-');

 KeysQMY:   KeyTxt =('QMY',
                     'MK_CNF','OPTMOD','LD_CNF','SV_CNF','  RAMP',
                     'OUTLIE','......','      ','      ','MAIN<-');

 KeysParam: KeyTxt =('Param',
                     '->PATH','->COLS','WCOLOR','WRTIMG','......',
                     '      ','      ','      ','      ','MAIN<-');

 KeysPfade: KeyTxt =('Paths',
                     '      ','  EDIT','LD_PFD','SV_PFD','      ',
                     '      ','      ','      ','      ','PARA<-');

 KeysFarbe: KeyTxt =('Colors',
                     '      ','  EDIT','LD_FRB','SV_FRB','      ',
                     '      ','      ','      ','      ','PARA<-');




procedure PlotKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPlot,TastePlot);
  case TastePlot of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      if not HistFertig then begin
                             ErrorMessage('No Histogram available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
                   PlotEigFrmHist(SlctLabel,HistType);
       WaitforReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   3: begin
      HistType:=(Histtype+1) mod 3;
      case HistType of
       0: KeysPlot[3]:=' EIGEN';
       1: KeysPlot[3]:=' FREMD';
       2: KeysPlot[3]:='  BOTH';
      end;
      end;
   4: begin
      s:=''; for k:=1 to KlAnz do s:=s+ClsLst[k]+' ';
      Message('Label from '+s+'or SpaceBar');
      s:=SlctLabel;
      repeat
       GetStr('Class Label : ',1,s);
       SlctLabel:=s[1];
      until SlctLabel in (ClSlct+[#32]);
      ClrDskTpG(ActPage);
      end;
   5: begin
      if not GlbwHistFertig then begin
                                 ErrorMessage('No Confidence Mapping available');
                                 WaitForReturn;
                                 ClrDskTpG(ActPage);
                                 end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       for k:=1 to KlAnz do if ((ClsLst[k]=SlctLabel) or (slctLabel=#32))
                               then PlotHistGlbw(k);
       WaitForReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   6: begin
      if not GlbwDatFertig then begin
                                ErrorMessage('No Confidence Mapping available');
                                WaitForReturn;
                                ClrDskTpG(ActPage);
                                end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       for k:=1 to KlAnz do if ((ClsLst[k]=SlctLabel) or (slctLabel=#32))
                               then PlotGlbw(k);
       WaitForReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   7: begin
      if not GlbwDatFertig then begin
                                ErrorMessage('No Confidence Mapping available');
                                WaitForReturn;
                                ClrDskTpG(ActPage);
                                end
      else
       begin
       ActPage:=1; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       for k:=1 to KlAnz do if ((ClsLst[k]=SlctLabel) or (slctLabel=#32))
                               then PlotOutl(k);
       WaitForReturn;
       ActPage:=0; SetActivePage(ActPage);
                   SetVisualPage(ActPage);
       end;
      end;
   8: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
    9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TastePlot=10;
 end;


procedure KoorKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysKoor,TasteKoor);
  case TasteKoor of
   1: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetColor(KoorColor);
                  KoorPlot(Koor);
                  SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   2: begin
      EditMskG(KoorMaske,OK,rm);
      ClrDskTpG(ActPage);
      KoorInit(KoorMaske.erg,Koor);
      end;
   3: begin
      Message('Select Inputfile Coordinate System');
      GtRdFileNameG(100,100,KoorPfad,KoorRdDatei);
      if not Leer(KoorRdDatei) then begin
                                    LoadMsk(KoorRdDatei,KoorMaske,OK);
                                    KoorInit(KoorMaske.erg,Koor);
                                    end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Coordinate System');
      GtWrFileNameG(100,100,KoorPfad,KoorSvDatei);
      if not Leer(KoorSvDatei) then SaveMsk(KoorSvDatei,KoorMaske,OK);
      ClrDskTpG(ActPage);
      end;
   5: begin
      {if ZchFld=scrn then ZchFld:=hcop else ZchFld:=scrn;
      KeysKoor[5]:=ZchFldStr(ZchFld);
      ZchFldInit;}
      end;
   8: begin
      ActPage:=1; SetVisualPage(ActPage);
      WaitforReturn;
      ActPage:=0; SetVisualPage(ActPage);
      end;
   9: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  ClrDsktpG(ActPage);
      WaitForReturn;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
  end;
 until TasteKoor=10;
 end;


procedure HistKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysHist,TasteHist);
  case TasteHist of
   1: begin
      if SrcDVekt then begin
                       Message('Select Inputfile Discriminant Vectors');
                       GtRdFileNameG(100,100,DvektPfad,RdDatei);
                       end
                  else begin
                       Message('Select Inputfile Measurement Vectors');
                       GtRdFileNameG(100,100,StchpPfad,RdDatei);
                       end;
      if not Leer(RdDatei) then
       begin
       EigFrmHistogramm(RdDatei,OK);
       HistFertig:=OK;
       end;
      ClrDskTpG(ActPage);
      end;
    2: begin
      Message('Determine Set of Class Labels');
      s:=''; for k:=1 to KlAnz do s:=s+ClsLst[k]+' ';
      OvWrt:=True;
      GetStr('List of Clas Labels: ',50,s);
      GetPar(s); KlAnz:=ParCount;
      for k:=1 to KlAnz do begin sc:=ParStr(k); ClsLst[k]:=sc[1]; end;
      ClSlctFromClsLst(ClsLst,KlAnz,ClSlct);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Histogram');
      GtRdFileNameG(100,100,HistPfad,HistRdDatei);
      if not Leer(HistRdDatei) then
       begin
       LoadEigFrmHist(HistRdDatei,OK);
       ClSlctFromClsLst(ClsLst,KlAnz,ClSlct);
       SlctLabel:=ClsLst[1];
       HistFertig:=OK;
       end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      if not HistFertig then begin
                             ErrorMessage('No Histogram available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       Message('Select Outputfile Histogram');
       GtWrFileNameG(100,100,HistPfad,HistSvDatei);
       if not Leer(HistSvDatei) then SaveEigFrmHist(HistSvDatei,OK);
       ClrDskTpG(ActPage);
       end;
      end;
   6: begin
      if not KLFGeladen then begin
                             ErrorMessage('No Classifier available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else begin
           SrcDVekt:=not SrcDVekt;
           if SrcDVekt then KeysHist[6]:='D_VECT'
                       else KeysHist[6]:='V_VECT';
           end;
      end;
  end;
 until TasteHist=10;
 end;


procedure QMYKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysQMY,TasteQMY);
  case TasteQMY of
   1: begin
      if not HistFertig then begin
                             ErrorMessage('No Histogram available');
                             WaitForReturn;
                             ClrDskTpG(ActPage);
                             end
      else
       begin
       GlbwHistFromHist;
       GlbwHistFertig:=True;
       end;
      end;
   2: begin
      if not GlbwHistFertig then begin
                                 ErrorMessage('No Confidence Histogram available');
                                 WaitForReturn;
                                 ClrDskTpG(ActPage);
                                 end
      else
      MakeGlbw;
      GlbwDatFertig:=True;
      end;
   3: begin
      Message('Select Inputfile Confidence Mapping');
      GtRdFileNameG(100,100,CnfPfad,CnfRdDatei);
      if not Leer(CnfRdDatei) then
       begin
       LoadGlbw(CnfRdDatei,OK);
       GlbwDatFertig:=True;
       CnfMap:=False; KeysParam[5]:='NO_CNF';
       end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      if not GlbwDatFertig then begin
                                ErrorMessage('No Confidence Mapping available');
                                WaitForReturn;
                                ClrDskTpG(ActPage);
                                end
      else
       begin
       Message('Select Outputfile Confidence Mapping');
       GtWrFileNameG(100,100,CnfPfad,CnfSvDatei);
       if not Leer(CnfSvDatei) then SaveGlbw(CnfSvDatei,OK);
       ClrDskTpG(ActPage);
       end;
      end;
   5: begin
      If GlbwDatFertig then begin
                            with GlbwDat do
                             begin
                             for k:=1 to anz do
                              begin
                              with dat[k] do
                               begin
                               param[2]:=0;
                               param[3]:=0;
                               param[4]:=1;
                               param[5]:=1
                               end;
                              end;
                             end;
                            end;
      end;
   6: begin
      Message('Determine Outlier-Quantile');
      GetWertR('OutlQuantil : ',OutlQuantil);
      ClrDskTpG(ActPage);
      end;
   7: begin
      PrtkOpt:=not PrtkOpt;
      if PrtkOpt then KeysQMY[7]:='  PRTC'
                 else KeysQMY[7]:='NOPRTC';
      end;
  end;
 until TasteQMY=10;
 end;


procedure PfadeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysPfade,TastePfade);
  case TastePfade of
   2: begin
      EditMskG(PfadeMaske,OK,rm);
      PfadeInitQMX(PfadeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Paths and Defaults');
      GtRdFileNameG(100,100,PfadePfad,PfadeRdDatei);
      if not Leer(PfadeRdDatei) then begin
                                     LoadMsk(PfadeRdDatei,PfadeMaske,OK);
                                     PfadeInitQMX(PfadeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Paths and Defaults');
      GtWrFileNameG(100,100,PfadePfad,PfadeSvDatei);
      if not Leer(PfadeSvDatei) then SaveMsk(PfadeSvDatei,PfadeMaske,OK);
      ClrDskTpG(ActPage);
      end;
  end;
 until TastePfade=10;
 end;


procedure FarbeKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysFarbe,TasteFarbe);
  case TasteFarbe of
   2: begin
      EditMskG(FarbeMaske,OK,rm);
      ColorInitQMX(FarbeMaske);
      ClrDskTpG(ActPage);
      end;
   3: begin
      Message('Select Inputfile Representation Parameters');
      GtRdFileNameG(100,100,FarbePfad,FarbeRdDatei);
      if not Leer(FarbeRdDatei) then begin
                                     LoadMsk(FarbeRdDatei,FarbeMaske,OK);
                                     ColorInitQMX(FarbeMaske);
                                     end;
      ClrDskTpG(ActPage);
      end;
   4: begin
      Message('Select Outputfile Representation Parameters');
      GtWrFileNameG(100,100,FarbePfad,FarbeSvDatei);
      if not Leer(FarbeSvDatei) then SaveMsk(FarbeSvDatei,FarbeMaske,OK);
      ClrDskTpG(ActPage);
      end;
  end;
 until TasteFarbe=10;
 end;


procedure ParamKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysParam,TasteParam);
  case TasteParam of
   1: PfadeKeys;
   2: FarbeKeys;
   3: begin
      repeat
       s:=ColorToStr(BeschrColor);
       OvWrt:=True;
       GetStr('Color for Writing Text in Image: ',12,s);
       BeschrColor:=ColorFromStr(s);
      until BeschrColor<=15;
      ClrDskTpG(ActPage);
      end;
   4: begin
      ActPage:=1; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
                  TextColor(BeschrColor);
                  TextBackGround(DsktpColor[ActPage]);
                  Beschrifte;
      ActPage:=0; SetActivePage(ActPage);
                  SetVisualPage(ActPage);
      end;
   5: begin
      if not (KlfDatFertig and GlbwDatFertig) then
       begin
       ErrorMessage('No Classifier and Confidence Mapping available');
       WaitForReturn;
       ClrDsktpG(ActPage);
       end
      else
      if CheckCompatKlfCnf then CnfMap:=not CnfMap else CnfMap:=False;
      if CnfMap then KeysParam[5]:='   CNF'
                else KeysParam[5]:='NO_CNF';
      end;

  end;
 until TasteParam=10;
 end;


procedure MainKeys;
 begin
 repeat
  GetFktTstG(550,8,KeysMain,TasteMain);
  case TasteMain of
   1: PlotKeys;
   2: KoorKeys;
   3: HistKeys;
   4: QMYKeys;
   6: begin
      Message('Select Inputfile Classifier');
      GtRdFileNameG(100,100,KlfPfad,KlfRdDatei);
      if not Leer(KlfRdDatei) then
        begin
        LoadKlf(KlfRdDatei,KlfDat,OK);
        KlfGeladen:=OK;
        CnfMap:=False; KeysParam[5]:='NO_CNF';
        ClsLstFromKlfDat(KlfDat,ClsLst,KlAnz);
        ClSlctFromClsLst(ClsLst,KlAnz,ClSlct);
        SlctLabel:=ClsLst[1];
        end;
      ClrDskTpG(ActPage);
      end;
   7: ParamKeys;
   8: begin
      RestoreCrtMode;
      SwapVectors;
      Exec(Editorpfad,'');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      ClrDskTpG(ActPage);
      end;
   9: begin
      w:=DskTpColor[ActPage];
      DskTpColor[ActPage]:=Black;
      ClrDskTpG(ActPage);
      RestoreCrtMode;
      SwapVectors;
      Exec('C:\COMMAND.COM','');
      SwapVectors;
      SetGraphMode(GrMd);
      MouseReset;
      DskTpColor[ActPage]:=w;
      ClrDskTpG(ActPage);
      end;
   end;
  until TasteMain=10;
 end;



begin
DetectGraph(GrDr,GrMd); GrMd:=1;
DtctGrphPar(ChrW,ChrH,AnzPxH,AnzPxV);
BGIPfad:=GetEnv('BGIPFAD');
InitGraph(GrDr,GrMd,BGIPfad);
MouseReset;

PfadePfad:=  '*.MSK';
PfadeRdDflt:='PFADQMY.MSK';
KoorRdDflt:= 'KOORQMY.MSK';
FarbeRdDflt:='FARBQMY.MSK';

ZchFld:=scrn; {KeysKoor[5]:= ZchFldStr(ZchFld);} ZchFldInit;


LoadMsk(PfadeRdDflt,PfadeMaske,OK);
 if not OK then WriteXYG(100,100,PfadeRdDflt+' not found')
           else PfadeInitQMY(PfadeMaske);
LoadMsk(KoorRdDatei,KoorMaske,OK);
 if not OK then WriteXYG(100,110,KoorRdDatei+' not found')
           else KoorInit(KoorMaske.erg,Koor);
LoadMsk(FarbeRdDatei,FarbeMaske,OK);
 if not OK then WriteXYG(100,130,FarbeRdDatei+' not found')
           else ColorInitQMY(FarbeMaske);


HistType:=2; KeysPlot[3]:='  BOTH';
ClsLst[1]:='0'; ClsLst[2]:='1';  ClsLst[3]:='2'; KlAnz:=3;
SlctLabel:=ClsLst[1];
ClSlctFromClsLst(ClsLst,KlAnz,ClSlct);
RdDatei:='';
DVektRdDatei:='';
KlfRdDatei:='';
ClrEigFrmHist;
OutlSchw:=10;
RadqSchw:=4.0;
HistFertig:=False;
EigFrmModFertig:=False;
SrcDvekt:=True; KeysHist[6] :='D_VECT';
PrtkOpt:=False; KeysQMY[7]  :='NOPRTC';
CnfMap:=False;  KeysParam[5]:='NO_CNF';
KlfGeladen:=False;
BeschrColor:=White;
GlbwHistFertig:=False;
GlbwDatFertig:=False;

ParGlbwMod     :=ParGlbwModInit;
OptStepGrad    :=OptStepGradInit;
OptStepGradMax :=64*OptStepGrad;
SimFakGrad     :=SimFakGradInit;
LimitGrad      :=LimitGradInit;

DsplOpt:=False;
OutlQuantil:=0.001;


ActPage:=1; {Grafikseite}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);
ActPage:=0; {Textseite im Grafikmode}
            SetActivePage(ActPage);
            ClrDsktpG(ActPage);

Titel('QMK -> QMY');

while WaitForReturnOrEscape do begin
                               ActPage:=0; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                                           ClrDsktpG(ActPage);
                                           MainKeys;
                               ActPage:=1; SetActivePage(ActPage);
                                           SetVisualPage(ActPage);
                               end;
Closegraph;
end.